/* Produced by CVXGEN, 2011-05-04 05:52:03 -0700.  */
/* CVXGEN is Copyright (C) 2006-2011 Jacob Mattingley, jem@cvxgen.com. */
/* The code in this file is Copyright (C) 2006-2011 Jacob Mattingley. */
/* CVXGEN, or solvers produced by CVXGEN, cannot be used for commercial */
/* applications without prior written permission from Jacob Mattingley. */

/* Filename: matrix_support.c. */
/* Description: Support functions for matrix multiplication and vector filling. */

#include "solver.h"

void multbymA(double *lhs, double *rhs) {
}

void multbymAT(double *lhs, double *rhs) {
  lhs[0] = 0;
  lhs[1] = 0;
  lhs[2] = 0;
  lhs[3] = 0;
  lhs[4] = 0;
  lhs[5] = 0;
  lhs[6] = 0;
  lhs[7] = 0;
  lhs[8] = 0;
  lhs[9] = 0;
  lhs[10] = 0;
}

void multbymG(double *lhs, double *rhs) {
  lhs[0] = -rhs[0]*(params.B[0])-rhs[1]*(params.B[3])-rhs[2]*(params.B[6])-rhs[3]*(params.B[9])-rhs[4]*(-1);
  lhs[1] = -rhs[0]*(params.B[1])-rhs[1]*(params.B[4])-rhs[2]*(params.B[7])-rhs[3]*(params.B[10])-rhs[5]*(-1);
  lhs[2] = -rhs[0]*(params.B[2])-rhs[1]*(params.B[5])-rhs[2]*(params.B[8])-rhs[3]*(params.B[11])-rhs[6]*(-1);
  lhs[3] = -rhs[0]*(-params.B[0])-rhs[1]*(-params.B[3])-rhs[2]*(-params.B[6])-rhs[3]*(-params.B[9])-rhs[4]*(-1);
  lhs[4] = -rhs[0]*(-params.B[1])-rhs[1]*(-params.B[4])-rhs[2]*(-params.B[7])-rhs[3]*(-params.B[10])-rhs[5]*(-1);
  lhs[5] = -rhs[0]*(-params.B[2])-rhs[1]*(-params.B[5])-rhs[2]*(-params.B[8])-rhs[3]*(-params.B[11])-rhs[6]*(-1);
  lhs[6] = -rhs[0]*(params.D[0])-rhs[7]*(-1);
  lhs[7] = -rhs[0]*(-params.D[0])-rhs[7]*(-1);
  lhs[8] = -rhs[1]*(params.D[1])-rhs[8]*(-1);
  lhs[9] = -rhs[1]*(-params.D[1])-rhs[8]*(-1);
  lhs[10] = -rhs[2]*(params.D[2])-rhs[9]*(-1);
  lhs[11] = -rhs[2]*(-params.D[2])-rhs[9]*(-1);
  lhs[12] = -rhs[3]*(params.D[3])-rhs[10]*(-1);
  lhs[13] = -rhs[3]*(-params.D[3])-rhs[10]*(-1);
  lhs[14] = -rhs[0]*(1);
  lhs[15] = -rhs[1]*(1);
  lhs[16] = -rhs[2]*(1);
  lhs[17] = -rhs[3]*(1);
  lhs[18] = -rhs[0]*(-1);
  lhs[19] = -rhs[1]*(-1);
  lhs[20] = -rhs[2]*(-1);
  lhs[21] = -rhs[3]*(-1);
}

void multbymGT(double *lhs, double *rhs) {
  lhs[0] = -rhs[0]*(params.B[0])-rhs[1]*(params.B[1])-rhs[2]*(params.B[2])-rhs[3]*(-params.B[0])-rhs[4]*(-params.B[1])-rhs[5]*(-params.B[2])-rhs[6]*(params.D[0])-rhs[7]*(-params.D[0])-rhs[14]*(1)-rhs[18]*(-1);
  lhs[1] = -rhs[0]*(params.B[3])-rhs[1]*(params.B[4])-rhs[2]*(params.B[5])-rhs[3]*(-params.B[3])-rhs[4]*(-params.B[4])-rhs[5]*(-params.B[5])-rhs[8]*(params.D[1])-rhs[9]*(-params.D[1])-rhs[15]*(1)-rhs[19]*(-1);
  lhs[2] = -rhs[0]*(params.B[6])-rhs[1]*(params.B[7])-rhs[2]*(params.B[8])-rhs[3]*(-params.B[6])-rhs[4]*(-params.B[7])-rhs[5]*(-params.B[8])-rhs[10]*(params.D[2])-rhs[11]*(-params.D[2])-rhs[16]*(1)-rhs[20]*(-1);
  lhs[3] = -rhs[0]*(params.B[9])-rhs[1]*(params.B[10])-rhs[2]*(params.B[11])-rhs[3]*(-params.B[9])-rhs[4]*(-params.B[10])-rhs[5]*(-params.B[11])-rhs[12]*(params.D[3])-rhs[13]*(-params.D[3])-rhs[17]*(1)-rhs[21]*(-1);
  lhs[4] = -rhs[0]*(-1)-rhs[3]*(-1);
  lhs[5] = -rhs[1]*(-1)-rhs[4]*(-1);
  lhs[6] = -rhs[2]*(-1)-rhs[5]*(-1);
  lhs[7] = -rhs[6]*(-1)-rhs[7]*(-1);
  lhs[8] = -rhs[8]*(-1)-rhs[9]*(-1);
  lhs[9] = -rhs[10]*(-1)-rhs[11]*(-1);
  lhs[10] = -rhs[12]*(-1)-rhs[13]*(-1);
}

void multbyP(double *lhs, double *rhs) {
  /* TODO use the fact that P is symmetric? */
  /* TODO check doubling / half factor etc. */
  lhs[0] = 0;
  lhs[1] = 0;
  lhs[2] = 0;
  lhs[3] = 0;
  lhs[4] = 0;
  lhs[5] = 0;
  lhs[6] = 0;
  lhs[7] = 0;
  lhs[8] = 0;
  lhs[9] = 0;
  lhs[10] = 0;
}

void fillq(void) {
  work.q[0] = 0;
  work.q[1] = 0;
  work.q[2] = 0;
  work.q[3] = 0;
  work.q[4] = 1;
  work.q[5] = 1;
  work.q[6] = 1;
  work.q[7] = params.alpha[0];
  work.q[8] = params.alpha[0];
  work.q[9] = params.alpha[0];
  work.q[10] = params.alpha[0];
}

void fillh(void) {
  work.h[0] = params.u[0];
  work.h[1] = params.u[1];
  work.h[2] = params.u[2];
  work.h[3] = -params.u[0];
  work.h[4] = -params.u[1];
  work.h[5] = -params.u[2];
  work.h[6] = 0;
  work.h[7] = 0;
  work.h[8] = 0;
  work.h[9] = 0;
  work.h[10] = 0;
  work.h[11] = 0;
  work.h[12] = 0;
  work.h[13] = 0;
  work.h[14] = params.deltamax[0];
  work.h[15] = params.deltamax[0];
  work.h[16] = params.deltamax[0];
  work.h[17] = params.deltamax[0];
  work.h[18] = -params.deltamin[0];
  work.h[19] = -params.deltamin[0];
  work.h[20] = -params.deltamin[0];
  work.h[21] = -params.deltamin[0];
}

void fillb(void) {
}

void pre_ops(void) {
}
