% clear all;
% clc;

Q = 55350;
m = 200; %kg
V = 300; %m/s

Iyy = 150; %kg*m^2
Izz = 150; %kg*m^2
Ixx = 5; %kg*m^2
Ixz = -1;
Ixy = -1;

s = 1;
c = 1;
g = 9.81;

CldP = 0.5; %1/rad
CmdP = 0.5; %1/rad
CldR = 0.6; %1/rad
CndR = 0.6;
CcdR = 0.6;
CldY = 0;
CndY = 0.4; %1/rad
CcdY = 0.4; %1/rad

Cla = 5; %1/rad
Cma = -5; %1/rad
Clp = -10;%-1; %1/rad
Cnp = 0.1;%-4; %1/rad
Clr = -0.7; %1/rad
Cnr = -8; %1/rad
Ccb = 0.8; %1/rad
Clb = 0;
Cnb = 0;
Cmq = -8;

%%% EFFICIENCY %%%

C_R_d1 = 0.3;
C_R_d2 = -0.3;
C_R_d3 = 0.4;
C_R_d4 = -0.4;
C_R_d5 = 0.9;
C_R_d6 = -0.9;

C_P_d1 = 0.8;
C_P_d2 = 0.8;
C_P_d3 = 0.6;
C_P_d4 = 0.6;
C_P_d5 = 0.7;
C_P_d6 = 0.7;

C_Y_d1 = -0.6;
C_Y_d2 = 0.6;
C_Y_d3 = 0.5;
C_Y_d4 = -0.5;
C_Y_d5 = -0.3;
C_Y_d6 = 0.3;

%%% ACTUATOR %%%
w0_1 = 150;
w0_2 = 150;
w0_3 = 150;
w0_4 = 150;
w0_5 = 10;
w0_6 = 10;
zeta_1 = 0.9;
zeta_2 = 0.9;
zeta_3 = 0.9;
zeta_4 = 0.9;
zeta_5 = 0.9;
zeta_6 = 0.9;

disp('Params OK');

run mpca_initializer_6d
run testsin

sigdot_new=0;
scalevec=0;