omega_n_1 = 150;
psi_1 = 0.9;

omega_n_2 = 150;
psi_2 = 0.9;

omega_n_3 = 150;
psi_3 = 0.9;

omega_n_4 = 150;
psi_4 = 0.9;

omega_n_5 = 10;
psi_5 = 0.9;

omega_n_6 = 10;
psi_6 = 0.9;

A1 = [ 0 1 ; -omega_n_1^2 -2*psi_1*omega_n_1 ];
A2 = [ 0 1 ; -omega_n_2^2 -2*psi_2*omega_n_2 ];
A3 = [ 0 1 ; -omega_n_3^2 -2*psi_3*omega_n_3 ];
A4 = [ 0 1 ; -omega_n_4^2 -2*psi_4*omega_n_4 ];
A5 = [ 0 1 ; -omega_n_5^2 -2*psi_5*omega_n_5 ];
A6 = [ 0 1 ; -omega_n_6^2 -2*psi_6*omega_n_6 ];
A = blkdiag(A1,A2,A3,A4,A5,A6);

B1 = [ 0 omega_n_1^2 ]';
B2 = [ 0 omega_n_2^2 ]';
B3 = [ 0 omega_n_3^2 ]';
B4 = [ 0 omega_n_4^2 ]';
B5 = [ 0 omega_n_5^2 ]';
B6 = [ 0 omega_n_6^2 ]';
B = blkdiag(B1,B2,B3,B4,B5,B6);

% C = [ 0.3 0 -0.3 0 0.4 0 -0.4 0 ;
%       0.8 0 0.8 0 0.8 0 0.8 0 ;
%       -0.6 0 0.6 0 0.5 0 -0.5 0];
  
C = [ C_R_d1 0 C_R_d2 0 C_R_d3 0 C_R_d4 0 C_R_d5 0 C_R_d6 0 ;
      C_P_d1 0 C_P_d2 0 C_P_d3 0 C_P_d4 0 C_P_d5 0 C_P_d6 0 ;
      C_Y_d1 0 C_Y_d2 0 C_Y_d3 0 C_Y_d4 0 C_Y_d5 0 C_Y_d6 0];
  
D = [ 1 1 1 1 0.1 0.1 ];
Ad = expm(A*0.05);
Bd = A\(Ad-eye(length(A(1,:))))*B;

params.A = Ad;
params.B = Bd;
params.C = C;
params.D = D;
params.alpha = 0.01;
params.deltamin = [ -20*pi/180 -20*pi/180 -20*pi/180 -20*pi/180 -10*pi/180 -10*pi/180 ]';
params.deltamax = [ 20*pi/180 20*pi/180 20*pi/180 20*pi/180 10*pi/180 10*pi/180 ]';
% params.deltamin = -10*pi/180;
% params.deltamax = 10*pi/180;
settings.verbose = 1;

params.delta_0 = zeros(12,1);
params.u_des_1 = [ 0 0 0 ]';
params.u_des_2 = [ 0 0 0 ]';
params.u_des_3 = [ 0 0 0 ]';
params.u_des_4 = [ 0 0 0 ]';
params.u_des_5 = [ 0 0 0 ]';

disp('MPCA OK');