/* Include files */

#include "blascompat32.h"
#include "flightsys_sfun.h"
#include "c5_flightsys.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "flightsys_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char *c5_debug_family_names[10] = { "settings", "delta_ex",
  "nargin", "nargout", "u_R", "u_Y", "u_P", "delta", "params", "delta_cmd" };

/* Function Declarations */
static void initialize_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance);
static void initialize_params_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance);
static void enable_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance);
static void disable_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance);
static void c5_update_debugger_state_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance);
static void set_sim_state_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance, const mxArray *c5_st);
static void finalize_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance);
static void sf_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber);
static const mxArray *c5_emlrt_marshallOut(SFc5_flightsysInstanceStruct
  *chartInstance, c5_struct_qrRyRFeWvq6RnKXrBrLhaB *c5_u);
static void c5_emlrt_marshallIn(SFc5_flightsysInstanceStruct *chartInstance,
  const mxArray *c5_delta_ex, const char_T *c5_name, real_T c5_y[6]);
static const mxArray *c5_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_b_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_c_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_d_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_e_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_f_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_g_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_h_sf_marshall(void *chartInstanceVoid, void *c5_u);
static void c5_b_emlrt_marshallIn(SFc5_flightsysInstanceStruct *chartInstance,
  const mxArray *c5_delta_cmd, const char_T *c5_name, real_T c5_y[6]);
static uint8_T c5_c_emlrt_marshallIn(SFc5_flightsysInstanceStruct *chartInstance,
  const mxArray *c5_b_is_active_c5_flightsys, const char_T *c5_name);
static void init_dsm_address_info(SFc5_flightsysInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c5_is_active_c5_flightsys = 0U;
}

static void initialize_params_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance)
{
  const mxArray *c5_m0 = NULL;
  const mxArray *c5_mxField;
  c5_struct_qrRyRFeWvq6RnKXrBrLhaB c5_r0;
  sf_set_error_prefix_string(
    "Embedded MATLAB Runtime Error (chart): Error evaluating data 'params' in the parent workspace.\n");
  c5_m0 = sf_mex_get_sfun_param(chartInstance->S, 0, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "A", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.A, 1, 0, 0U, 1, 0U, 2,
                12, 12);
  c5_mxField = sf_mex_getfield(c5_m0, "B", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.B, 1, 0, 0U, 1, 0U, 2,
                12, 6);
  c5_mxField = sf_mex_getfield(c5_m0, "C", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.C, 1, 0, 0U, 1, 0U, 2,
                3, 12);
  c5_mxField = sf_mex_getfield(c5_m0, "D", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.D, 1, 0, 0U, 1, 0U, 2,
                1, 6);
  c5_mxField = sf_mex_getfield(c5_m0, "alpha", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.alpha, 1, 0, 0U, 0, 0U,
                0);
  c5_mxField = sf_mex_getfield(c5_m0, "deltamin", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.deltamin, 1, 0, 0U, 1,
                0U, 2, 6, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "deltamax", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.deltamax, 1, 0, 0U, 1,
                0U, 2, 6, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "delta_0", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.delta_0, 1, 0, 0U, 1,
                0U, 2, 12, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "u_des_1", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.u_des_1, 1, 0, 0U, 1,
                0U, 2, 3, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "u_des_2", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.u_des_2, 1, 0, 0U, 1,
                0U, 2, 3, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "u_des_3", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.u_des_3, 1, 0, 0U, 1,
                0U, 2, 3, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "u_des_4", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.u_des_4, 1, 0, 0U, 1,
                0U, 2, 3, 1);
  c5_mxField = sf_mex_getfield(c5_m0, "u_des_5", "params", 0);
  sf_mex_import("params", sf_mex_dup(c5_mxField), &c5_r0.u_des_5, 1, 0, 0U, 1,
                0U, 2, 3, 1);
  sf_mex_destroy(&c5_m0);
  chartInstance->c5_params = c5_r0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c5_update_debugger_state_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance)
{
  const mxArray *c5_st = NULL;
  const mxArray *c5_y = NULL;
  int32_T c5_i0;
  real_T c5_hoistedGlobal[6];
  int32_T c5_i1;
  real_T c5_u[6];
  const mxArray *c5_b_y = NULL;
  uint8_T c5_b_hoistedGlobal;
  uint8_T c5_b_u;
  const mxArray *c5_c_y = NULL;
  real_T (*c5_delta_cmd)[6];
  c5_delta_cmd = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c5_st = NULL;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_createcellarray(2));
  for (c5_i0 = 0; c5_i0 < 6; c5_i0 = c5_i0 + 1) {
    c5_hoistedGlobal[c5_i0] = (*c5_delta_cmd)[c5_i0];
  }

  for (c5_i1 = 0; c5_i1 < 6; c5_i1 = c5_i1 + 1) {
    c5_u[c5_i1] = c5_hoistedGlobal[c5_i1];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_setcell(c5_y, 0, c5_b_y);
  c5_b_hoistedGlobal = chartInstance->c5_is_active_c5_flightsys;
  c5_b_u = c5_b_hoistedGlobal;
  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create("y", &c5_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c5_y, 1, c5_c_y);
  sf_mex_assign(&c5_st, c5_y);
  return c5_st;
}

static void set_sim_state_c5_flightsys(SFc5_flightsysInstanceStruct
  *chartInstance, const mxArray *c5_st)
{
  const mxArray *c5_u;
  real_T c5_dv0[6];
  int32_T c5_i2;
  real_T (*c5_delta_cmd)[6];
  c5_delta_cmd = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c5_doneDoubleBufferReInit = TRUE;
  c5_u = sf_mex_dup(c5_st);
  c5_b_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c5_u, 0)),
                        "delta_cmd", c5_dv0);
  for (c5_i2 = 0; c5_i2 < 6; c5_i2 = c5_i2 + 1) {
    (*c5_delta_cmd)[c5_i2] = c5_dv0[c5_i2];
  }

  chartInstance->c5_is_active_c5_flightsys = c5_c_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c5_u, 1)),
    "is_active_c5_flightsys");
  sf_mex_destroy(&c5_u);
  c5_update_debugger_state_c5_flightsys(chartInstance);
  sf_mex_destroy(&c5_st);
}

static void finalize_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance)
{
}

static void sf_c5_flightsys(SFc5_flightsysInstanceStruct *chartInstance)
{
  int32_T c5_i3;
  int32_T c5_i4;
  int32_T c5_i5;
  int32_T c5_i6;
  int32_T c5_i7;
  int32_T c5_previousEvent;
  int32_T c5_i8;
  real_T c5_hoistedGlobal[5];
  int32_T c5_i9;
  real_T c5_b_hoistedGlobal[5];
  int32_T c5_i10;
  real_T c5_c_hoistedGlobal[5];
  int32_T c5_i11;
  real_T c5_d_hoistedGlobal[6];
  c5_struct_qrRyRFeWvq6RnKXrBrLhaB c5_e_hoistedGlobal;
  int32_T c5_i12;
  real_T c5_u_R[5];
  int32_T c5_i13;
  real_T c5_u_Y[5];
  int32_T c5_i14;
  real_T c5_u_P[5];
  int32_T c5_i15;
  real_T c5_delta[6];
  c5_struct_qrRyRFeWvq6RnKXrBrLhaB c5_b_params;
  uint32_T c5_debug_family_var_map[10];
  struct sGahFmRupzQTjvjnM9DdYgE c5_settings;
  const mxArray *c5_delta_ex = NULL;
  real_T c5_nargin = 5.0;
  real_T c5_nargout = 1.0;
  real_T c5_delta_cmd[6];
  int32_T c5_i16;
  real_T c5_b_delta[12];
  int32_T c5_i17;
  real_T c5_b_u_R[3];
  int32_T c5_i18;
  real_T c5_c_u_R[3];
  int32_T c5_i19;
  real_T c5_d_u_R[3];
  int32_T c5_i20;
  real_T c5_e_u_R[3];
  int32_T c5_i21;
  real_T c5_f_u_R[3];
  int32_T c5_i22;
  struct sGahFmRupzQTjvjnM9DdYgE c5_u;
  const mxArray *c5_y = NULL;
  real_T c5_b_u;
  const mxArray *c5_b_y = NULL;
  c5_struct_qrRyRFeWvq6RnKXrBrLhaB c5_c_params;
  real_T c5_dv1[6];
  int32_T c5_i23;
  int32_T c5_i24;
  real_T (*c5_b_delta_cmd)[6];
  real_T (*c5_c_delta)[6];
  real_T (*c5_b_u_P)[5];
  real_T (*c5_b_u_Y)[5];
  real_T (*c5_g_u_R)[5];
  c5_c_delta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 3);
  c5_b_u_P = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 2);
  c5_b_u_Y = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 1);
  c5_g_u_R = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 0);
  c5_b_delta_cmd = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,3);
  for (c5_i3 = 0; c5_i3 < 6; c5_i3 = c5_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_b_delta_cmd)[c5_i3], 0U);
  }

  for (c5_i4 = 0; c5_i4 < 5; c5_i4 = c5_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_g_u_R)[c5_i4], 1U);
  }

  for (c5_i5 = 0; c5_i5 < 5; c5_i5 = c5_i5 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_b_u_Y)[c5_i5], 2U);
  }

  for (c5_i6 = 0; c5_i6 < 5; c5_i6 = c5_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_b_u_P)[c5_i6], 3U);
  }

  for (c5_i7 = 0; c5_i7 < 6; c5_i7 = c5_i7 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_c_delta)[c5_i7], 4U);
  }

  c5_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,3);
  for (c5_i8 = 0; c5_i8 < 5; c5_i8 = c5_i8 + 1) {
    c5_hoistedGlobal[c5_i8] = (*c5_g_u_R)[c5_i8];
  }

  for (c5_i9 = 0; c5_i9 < 5; c5_i9 = c5_i9 + 1) {
    c5_b_hoistedGlobal[c5_i9] = (*c5_b_u_Y)[c5_i9];
  }

  for (c5_i10 = 0; c5_i10 < 5; c5_i10 = c5_i10 + 1) {
    c5_c_hoistedGlobal[c5_i10] = (*c5_b_u_P)[c5_i10];
  }

  for (c5_i11 = 0; c5_i11 < 6; c5_i11 = c5_i11 + 1) {
    c5_d_hoistedGlobal[c5_i11] = (*c5_c_delta)[c5_i11];
  }

  c5_e_hoistedGlobal = chartInstance->c5_params;
  for (c5_i12 = 0; c5_i12 < 5; c5_i12 = c5_i12 + 1) {
    c5_u_R[c5_i12] = c5_hoistedGlobal[c5_i12];
  }

  for (c5_i13 = 0; c5_i13 < 5; c5_i13 = c5_i13 + 1) {
    c5_u_Y[c5_i13] = c5_b_hoistedGlobal[c5_i13];
  }

  for (c5_i14 = 0; c5_i14 < 5; c5_i14 = c5_i14 + 1) {
    c5_u_P[c5_i14] = c5_c_hoistedGlobal[c5_i14];
  }

  for (c5_i15 = 0; c5_i15 < 6; c5_i15 = c5_i15 + 1) {
    c5_delta[c5_i15] = c5_d_hoistedGlobal[c5_i15];
  }

  c5_b_params = c5_e_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c5_debug_family_names,
    c5_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c5_settings, c5_g_sf_marshall, 0U);
  sf_debug_symbol_scope_add_eml(&c5_delta_ex, c5_f_sf_marshall, 1U);
  sf_debug_symbol_scope_add_eml(&c5_nargin, c5_e_sf_marshall, 2U);
  sf_debug_symbol_scope_add_eml(&c5_nargout, c5_e_sf_marshall, 3U);
  sf_debug_symbol_scope_add_eml(&c5_u_R, c5_d_sf_marshall, 4U);
  sf_debug_symbol_scope_add_eml(&c5_u_Y, c5_d_sf_marshall, 5U);
  sf_debug_symbol_scope_add_eml(&c5_u_P, c5_c_sf_marshall, 6U);
  sf_debug_symbol_scope_add_eml(&c5_delta, c5_sf_marshall, 7U);
  sf_debug_symbol_scope_add_eml(&c5_b_params, c5_b_sf_marshall, 8U);
  sf_debug_symbol_scope_add_eml(&c5_delta_cmd, c5_sf_marshall, 9U);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  _SFD_EML_CALL(0,5);
  for (c5_i16 = 0; c5_i16 < 6; c5_i16 = c5_i16 + 1) {
    c5_delta_cmd[c5_i16] = 0.0;
  }

  _SFD_EML_CALL(0,7);
  c5_b_delta[0] = c5_delta[0];
  c5_b_delta[1] = 0.0;
  c5_b_delta[2] = c5_delta[1];
  c5_b_delta[3] = 0.0;
  c5_b_delta[4] = c5_delta[2];
  c5_b_delta[5] = 0.0;
  c5_b_delta[6] = c5_delta[3];
  c5_b_delta[7] = 0.0;
  c5_b_delta[8] = c5_delta[4];
  c5_b_delta[9] = 0.0;
  c5_b_delta[10] = c5_delta[5];
  c5_b_delta[11] = 0.0;
  for (c5_i17 = 0; c5_i17 < 12; c5_i17 = c5_i17 + 1) {
    c5_b_params.delta_0[c5_i17] = c5_b_delta[c5_i17];
  }

  _SFD_EML_CALL(0,8);
  c5_b_u_R[0] = c5_u_R[0];
  c5_b_u_R[1] = c5_u_P[0];
  c5_b_u_R[2] = c5_u_Y[0];
  for (c5_i18 = 0; c5_i18 < 3; c5_i18 = c5_i18 + 1) {
    c5_b_params.u_des_1[c5_i18] = c5_b_u_R[c5_i18];
  }

  _SFD_EML_CALL(0,9);
  c5_c_u_R[0] = c5_u_R[1];
  c5_c_u_R[1] = c5_u_P[1];
  c5_c_u_R[2] = c5_u_Y[1];
  for (c5_i19 = 0; c5_i19 < 3; c5_i19 = c5_i19 + 1) {
    c5_b_params.u_des_2[c5_i19] = c5_c_u_R[c5_i19];
  }

  _SFD_EML_CALL(0,10);
  c5_d_u_R[0] = c5_u_R[2];
  c5_d_u_R[1] = c5_u_P[2];
  c5_d_u_R[2] = c5_u_Y[2];
  for (c5_i20 = 0; c5_i20 < 3; c5_i20 = c5_i20 + 1) {
    c5_b_params.u_des_3[c5_i20] = c5_d_u_R[c5_i20];
  }

  _SFD_EML_CALL(0,11);
  c5_e_u_R[0] = c5_u_R[3];
  c5_e_u_R[1] = c5_u_P[3];
  c5_e_u_R[2] = c5_u_Y[3];
  for (c5_i21 = 0; c5_i21 < 3; c5_i21 = c5_i21 + 1) {
    c5_b_params.u_des_4[c5_i21] = c5_e_u_R[c5_i21];
  }

  _SFD_EML_CALL(0,12);
  c5_f_u_R[0] = c5_u_R[4];
  c5_f_u_R[1] = c5_u_P[4];
  c5_f_u_R[2] = c5_u_Y[4];
  for (c5_i22 = 0; c5_i22 < 3; c5_i22 = c5_i22 + 1) {
    c5_b_params.u_des_5[c5_i22] = c5_f_u_R[c5_i22];
  }

  _SFD_EML_CALL(0,13);
  c5_settings.verbose = 0.0;
  _SFD_EML_CALL(0,15);
  c5_u = c5_settings;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_createstruct("structure", 2, 1, 1));
  c5_b_u = c5_u.verbose;
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_addfield(c5_y, c5_b_y, "verbose", "verbose", 0);
  c5_c_params = c5_b_params;
  sf_mex_assign(&c5_delta_ex, sf_mex_call_debug("mpca_external", 1U, 2U, 14,
    c5_emlrt_marshallOut(chartInstance, &c5_c_params), 14,
    c5_y));
  _SFD_EML_CALL(0,16);
  c5_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_delta_ex), "delta_ex", c5_dv1);
  for (c5_i23 = 0; c5_i23 < 6; c5_i23 = c5_i23 + 1) {
    c5_delta_cmd[c5_i23] = c5_dv1[c5_i23];
  }

  _SFD_EML_CALL(0,-16);
  sf_debug_symbol_scope_pop();
  sf_mex_destroy(&c5_delta_ex);
  for (c5_i24 = 0; c5_i24 < 6; c5_i24 = c5_i24 + 1) {
    (*c5_b_delta_cmd)[c5_i24] = c5_delta_cmd[c5_i24];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,3);
  _sfEvent_ = c5_previousEvent;
  sf_debug_check_for_state_inconsistency(_flightsysMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber)
{
}

static const mxArray *c5_emlrt_marshallOut(SFc5_flightsysInstanceStruct
  *chartInstance, c5_struct_qrRyRFeWvq6RnKXrBrLhaB *c5_u)
{
  const mxArray *c5_y = NULL;
  int32_T c5_i25;
  real_T c5_b_u[144];
  const mxArray *c5_b_y = NULL;
  int32_T c5_i26;
  real_T c5_c_u[72];
  const mxArray *c5_c_y = NULL;
  int32_T c5_i27;
  real_T c5_d_u[36];
  const mxArray *c5_d_y = NULL;
  int32_T c5_i28;
  real_T c5_e_u[6];
  const mxArray *c5_e_y = NULL;
  real_T c5_f_u;
  const mxArray *c5_f_y = NULL;
  int32_T c5_i29;
  real_T c5_g_u[6];
  const mxArray *c5_g_y = NULL;
  int32_T c5_i30;
  real_T c5_h_u[6];
  const mxArray *c5_h_y = NULL;
  int32_T c5_i31;
  real_T c5_i_u[12];
  const mxArray *c5_i_y = NULL;
  int32_T c5_i32;
  real_T c5_j_u[3];
  const mxArray *c5_j_y = NULL;
  int32_T c5_i33;
  real_T c5_k_u[3];
  const mxArray *c5_k_y = NULL;
  int32_T c5_i34;
  real_T c5_l_u[3];
  const mxArray *c5_l_y = NULL;
  int32_T c5_i35;
  real_T c5_m_u[3];
  const mxArray *c5_m_y = NULL;
  int32_T c5_i36;
  real_T c5_n_u[3];
  const mxArray *c5_n_y = NULL;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_createstruct("structure", 2, 1, 1));
  for (c5_i25 = 0; c5_i25 < 144; c5_i25 = c5_i25 + 1) {
    c5_b_u[c5_i25] = c5_u->A[c5_i25];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 1U, 0U, 2, 12, 12));
  sf_mex_addfield(c5_y, c5_b_y, "A", "A", 0);
  for (c5_i26 = 0; c5_i26 < 72; c5_i26 = c5_i26 + 1) {
    c5_c_u[c5_i26] = c5_u->B[c5_i26];
  }

  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create("y", &c5_c_u, 0, 0U, 1U, 0U, 2, 12, 6));
  sf_mex_addfield(c5_y, c5_c_y, "B", "B", 0);
  for (c5_i27 = 0; c5_i27 < 36; c5_i27 = c5_i27 + 1) {
    c5_d_u[c5_i27] = c5_u->C[c5_i27];
  }

  c5_d_y = NULL;
  sf_mex_assign(&c5_d_y, sf_mex_create("y", &c5_d_u, 0, 0U, 1U, 0U, 2, 3, 12));
  sf_mex_addfield(c5_y, c5_d_y, "C", "C", 0);
  for (c5_i28 = 0; c5_i28 < 6; c5_i28 = c5_i28 + 1) {
    c5_e_u[c5_i28] = c5_u->D[c5_i28];
  }

  c5_e_y = NULL;
  sf_mex_assign(&c5_e_y, sf_mex_create("y", &c5_e_u, 0, 0U, 1U, 0U, 2, 1, 6));
  sf_mex_addfield(c5_y, c5_e_y, "D", "D", 0);
  c5_f_u = c5_u->alpha;
  c5_f_y = NULL;
  sf_mex_assign(&c5_f_y, sf_mex_create("y", &c5_f_u, 0, 0U, 0U, 0U, 0));
  sf_mex_addfield(c5_y, c5_f_y, "alpha", "alpha", 0);
  for (c5_i29 = 0; c5_i29 < 6; c5_i29 = c5_i29 + 1) {
    c5_g_u[c5_i29] = c5_u->deltamin[c5_i29];
  }

  c5_g_y = NULL;
  sf_mex_assign(&c5_g_y, sf_mex_create("y", &c5_g_u, 0, 0U, 1U, 0U, 2, 6, 1));
  sf_mex_addfield(c5_y, c5_g_y, "deltamin", "deltamin", 0);
  for (c5_i30 = 0; c5_i30 < 6; c5_i30 = c5_i30 + 1) {
    c5_h_u[c5_i30] = c5_u->deltamax[c5_i30];
  }

  c5_h_y = NULL;
  sf_mex_assign(&c5_h_y, sf_mex_create("y", &c5_h_u, 0, 0U, 1U, 0U, 2, 6, 1));
  sf_mex_addfield(c5_y, c5_h_y, "deltamax", "deltamax", 0);
  for (c5_i31 = 0; c5_i31 < 12; c5_i31 = c5_i31 + 1) {
    c5_i_u[c5_i31] = c5_u->delta_0[c5_i31];
  }

  c5_i_y = NULL;
  sf_mex_assign(&c5_i_y, sf_mex_create("y", &c5_i_u, 0, 0U, 1U, 0U, 2, 12, 1));
  sf_mex_addfield(c5_y, c5_i_y, "delta_0", "delta_0", 0);
  for (c5_i32 = 0; c5_i32 < 3; c5_i32 = c5_i32 + 1) {
    c5_j_u[c5_i32] = c5_u->u_des_1[c5_i32];
  }

  c5_j_y = NULL;
  sf_mex_assign(&c5_j_y, sf_mex_create("y", &c5_j_u, 0, 0U, 1U, 0U, 2, 3, 1));
  sf_mex_addfield(c5_y, c5_j_y, "u_des_1", "u_des_1", 0);
  for (c5_i33 = 0; c5_i33 < 3; c5_i33 = c5_i33 + 1) {
    c5_k_u[c5_i33] = c5_u->u_des_2[c5_i33];
  }

  c5_k_y = NULL;
  sf_mex_assign(&c5_k_y, sf_mex_create("y", &c5_k_u, 0, 0U, 1U, 0U, 2, 3, 1));
  sf_mex_addfield(c5_y, c5_k_y, "u_des_2", "u_des_2", 0);
  for (c5_i34 = 0; c5_i34 < 3; c5_i34 = c5_i34 + 1) {
    c5_l_u[c5_i34] = c5_u->u_des_3[c5_i34];
  }

  c5_l_y = NULL;
  sf_mex_assign(&c5_l_y, sf_mex_create("y", &c5_l_u, 0, 0U, 1U, 0U, 2, 3, 1));
  sf_mex_addfield(c5_y, c5_l_y, "u_des_3", "u_des_3", 0);
  for (c5_i35 = 0; c5_i35 < 3; c5_i35 = c5_i35 + 1) {
    c5_m_u[c5_i35] = c5_u->u_des_4[c5_i35];
  }

  c5_m_y = NULL;
  sf_mex_assign(&c5_m_y, sf_mex_create("y", &c5_m_u, 0, 0U, 1U, 0U, 2, 3, 1));
  sf_mex_addfield(c5_y, c5_m_y, "u_des_4", "u_des_4", 0);
  for (c5_i36 = 0; c5_i36 < 3; c5_i36 = c5_i36 + 1) {
    c5_n_u[c5_i36] = c5_u->u_des_5[c5_i36];
  }

  c5_n_y = NULL;
  sf_mex_assign(&c5_n_y, sf_mex_create("y", &c5_n_u, 0, 0U, 1U, 0U, 2, 3, 1));
  sf_mex_addfield(c5_y, c5_n_y, "u_des_5", "u_des_5", 0);
  return c5_y;
}

static void c5_emlrt_marshallIn(SFc5_flightsysInstanceStruct *chartInstance,
  const mxArray *c5_delta_ex, const char_T *c5_name,
  real_T c5_y[6])
{
  real_T c5_dv2[6];
  int32_T c5_i37;
  sf_mex_import(c5_name, sf_mex_dup(c5_delta_ex), &c5_dv2, 1, 0, 0U, 1, 0U, 1, 6);
  for (c5_i37 = 0; c5_i37 < 6; c5_i37 = c5_i37 + 1) {
    c5_y[c5_i37] = c5_dv2[c5_i37];
  }

  sf_mex_destroy(&c5_delta_ex);
}

static const mxArray *c5_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  int32_T c5_i38;
  real_T c5_b_u[6];
  const mxArray *c5_b_y = NULL;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  for (c5_i38 = 0; c5_i38 < 6; c5_i38 = c5_i38 + 1) {
    c5_b_u[c5_i38] = (*((real_T (*)[6])c5_u))[c5_i38];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

static const mxArray *c5_b_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  c5_struct_qrRyRFeWvq6RnKXrBrLhaB c5_b_u;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  c5_b_u = *((c5_struct_qrRyRFeWvq6RnKXrBrLhaB *)c5_u);
  sf_mex_assign(&c5_y, c5_emlrt_marshallOut(chartInstance, &c5_b_u));
  return c5_y;
}

static const mxArray *c5_c_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  int32_T c5_i39;
  real_T c5_b_u[5];
  const mxArray *c5_b_y = NULL;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  for (c5_i39 = 0; c5_i39 < 5; c5_i39 = c5_i39 + 1) {
    c5_b_u[c5_i39] = (*((real_T (*)[5])c5_u))[c5_i39];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 1U, 0U, 1, 5));
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

static const mxArray *c5_d_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  int32_T c5_i40;
  real_T c5_b_u[5];
  const mxArray *c5_b_y = NULL;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  for (c5_i40 = 0; c5_i40 < 5; c5_i40 = c5_i40 + 1) {
    c5_b_u[c5_i40] = (*((real_T (*)[5])c5_u))[c5_i40];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 1U, 0U, 2, 1, 5));
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

static const mxArray *c5_e_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  real_T c5_b_u;
  const mxArray *c5_b_y = NULL;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  c5_b_u = *((real_T *)c5_u);
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

static const mxArray *c5_f_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  const mxArray *c5_b_u;
  const mxArray *c5_b_y = NULL;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  c5_b_u = sf_mex_dup(*((const mxArray **)c5_u));
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_duplicatearraysafe(&c5_b_u));
  sf_mex_destroy(&c5_b_u);
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

static const mxArray *c5_g_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  struct sGahFmRupzQTjvjnM9DdYgE c5_b_u;
  const mxArray *c5_b_y = NULL;
  real_T c5_c_u;
  const mxArray *c5_c_y = NULL;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  c5_b_u = *((struct sGahFmRupzQTjvjnM9DdYgE *)c5_u);
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_createstruct("structure", 2, 1, 1));
  c5_c_u = c5_b_u.verbose;
  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create("y", &c5_c_u, 0, 0U, 0U, 0U, 0));
  sf_mex_addfield(c5_b_y, c5_c_y, "verbose", "verbose", 0);
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

const mxArray *sf_c5_flightsys_get_eml_resolved_functions_info(void)
{
  const mxArray *c5_nameCaptureInfo = NULL;
  c5_ResolvedFunctionInfo c5_info[1];
  c5_ResolvedFunctionInfo (*c5_b_info)[1];
  const mxArray *c5_m1 = NULL;
  int32_T c5_i41;
  c5_ResolvedFunctionInfo *c5_r1;
  c5_nameCaptureInfo = NULL;
  c5_b_info = (c5_ResolvedFunctionInfo (*)[1])c5_info;
  (*c5_b_info)[0].context = "";
  (*c5_b_info)[0].name = "ctranspose";
  (*c5_b_info)[0].dominantType = "double";
  (*c5_b_info)[0].resolved = "[B]ctranspose";
  (*c5_b_info)[0].fileLength = 0U;
  (*c5_b_info)[0].fileTime1 = 0U;
  (*c5_b_info)[0].fileTime2 = 0U;
  sf_mex_assign(&c5_m1, sf_mex_createstruct("nameCaptureInfo", 1, 1));
  for (c5_i41 = 0; c5_i41 < 1; c5_i41 = c5_i41 + 1) {
    c5_r1 = &c5_info[c5_i41];
    sf_mex_addfield(c5_m1, sf_mex_create("nameCaptureInfo", c5_r1->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r1->context)), "context",
                    "nameCaptureInfo", c5_i41);
    sf_mex_addfield(c5_m1, sf_mex_create("nameCaptureInfo", c5_r1->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c5_r1->name)), "name",
                    "nameCaptureInfo", c5_i41);
    sf_mex_addfield(c5_m1, sf_mex_create("nameCaptureInfo", c5_r1->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c5_r1->dominantType)),
                    "dominantType", "nameCaptureInfo", c5_i41);
    sf_mex_addfield(c5_m1, sf_mex_create("nameCaptureInfo", c5_r1->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r1->resolved)), "resolved"
                    , "nameCaptureInfo", c5_i41);
    sf_mex_addfield(c5_m1, sf_mex_create("nameCaptureInfo", &c5_r1->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c5_i41);
    sf_mex_addfield(c5_m1, sf_mex_create("nameCaptureInfo", &c5_r1->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c5_i41
                    );
    sf_mex_addfield(c5_m1, sf_mex_create("nameCaptureInfo", &c5_r1->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c5_i41
                    );
  }

  sf_mex_assign(&c5_nameCaptureInfo, c5_m1);
  return c5_nameCaptureInfo;
}

static const mxArray *c5_h_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_y = NULL;
  boolean_T c5_b_u;
  const mxArray *c5_b_y = NULL;
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)chartInstanceVoid;
  c5_y = NULL;
  c5_b_u = *((boolean_T *)c5_u);
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 11, 0U, 0U, 0U, 0));
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

static void c5_b_emlrt_marshallIn(SFc5_flightsysInstanceStruct *chartInstance,
  const mxArray *c5_delta_cmd, const char_T *c5_name,
  real_T c5_y[6])
{
  real_T c5_dv3[6];
  int32_T c5_i42;
  sf_mex_import(c5_name, sf_mex_dup(c5_delta_cmd), &c5_dv3, 1, 0, 0U, 1, 0U, 1,
                6);
  for (c5_i42 = 0; c5_i42 < 6; c5_i42 = c5_i42 + 1) {
    c5_y[c5_i42] = c5_dv3[c5_i42];
  }

  sf_mex_destroy(&c5_delta_cmd);
}

static uint8_T c5_c_emlrt_marshallIn(SFc5_flightsysInstanceStruct *chartInstance,
  const mxArray *c5_b_is_active_c5_flightsys, const
  char_T *c5_name)
{
  uint8_T c5_y;
  uint8_T c5_u0;
  sf_mex_import(c5_name, sf_mex_dup(c5_b_is_active_c5_flightsys), &c5_u0, 1, 3,
                0U, 0, 0U, 0);
  c5_y = c5_u0;
  sf_mex_destroy(&c5_b_is_active_c5_flightsys);
  return c5_y;
}

static void init_dsm_address_info(SFc5_flightsysInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c5_flightsys_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2907929219U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3113834408U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1115834198U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3889290451U);
}

mxArray *sf_c5_flightsys_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(143823176U);
    pr[1] = (double)(2409485712U);
    pr[2] = (double)(3252703133U);
    pr[3] = (double)(2799229064U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(5);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(5);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(5);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c5_flightsys(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[6],T\"delta_cmd\",},{M[8],M[0],T\"is_active_c5_flightsys\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c5_flightsys_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc5_flightsysInstanceStruct *chartInstance;
    chartInstance = (SFc5_flightsysInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_flightsysMachineNumber_,
          5,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_flightsysMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_flightsysMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_flightsysMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta_cmd",0,(MexFcnForType)
                                c5_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 1;
            dimVector[1]= 5;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"u_R",0,(MexFcnForType)c5_d_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 1;
            dimVector[1]= 5;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"u_Y",0,(MexFcnForType)c5_d_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 5;
            _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"u_P",0,(MexFcnForType)c5_c_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"delta",0,(MexFcnForType)c5_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(5,10,0,0,SF_STRUCT,0,NULL,0,0,0,0.0,1.0,0,"params",
                              0,(MexFcnForType)c5_b_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,572);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c5_delta_cmd)[6];
          real_T (*c5_u_R)[5];
          real_T (*c5_u_Y)[5];
          real_T (*c5_u_P)[5];
          real_T (*c5_delta)[6];
          c5_delta = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 3);
          c5_u_P = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 2);
          c5_u_Y = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 1);
          c5_u_R = (real_T (*)[5])ssGetInputPortSignal(chartInstance->S, 0);
          c5_delta_cmd = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S,
            1);
          _SFD_SET_DATA_VALUE_PTR(0U, c5_delta_cmd);
          _SFD_SET_DATA_VALUE_PTR(1U, c5_u_R);
          _SFD_SET_DATA_VALUE_PTR(2U, c5_u_Y);
          _SFD_SET_DATA_VALUE_PTR(3U, c5_u_P);
          _SFD_SET_DATA_VALUE_PTR(4U, c5_delta);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c5_params);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_flightsysMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c5_flightsys(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc5_flightsysInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c5_flightsys((SFc5_flightsysInstanceStruct*)
    chartInstanceVar);
  initialize_c5_flightsys((SFc5_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c5_flightsys(void *chartInstanceVar)
{
  enable_c5_flightsys((SFc5_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c5_flightsys(void *chartInstanceVar)
{
  disable_c5_flightsys((SFc5_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c5_flightsys(void *chartInstanceVar)
{
  sf_c5_flightsys((SFc5_flightsysInstanceStruct*) chartInstanceVar);
}

static mxArray* sf_internal_get_sim_state_c5_flightsys(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c5_flightsys((SFc5_flightsysInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = sf_get_sim_state_info_c5_flightsys();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

static void sf_internal_set_sim_state_c5_flightsys(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c5_flightsys();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c5_flightsys((SFc5_flightsysInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static mxArray* sf_opaque_get_sim_state_c5_flightsys(SimStruct* S)
{
  return sf_internal_get_sim_state_c5_flightsys(S);
}

static void sf_opaque_set_sim_state_c5_flightsys(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c5_flightsys(S, st);
}

static void sf_opaque_terminate_c5_flightsys(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc5_flightsysInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c5_flightsys((SFc5_flightsysInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c5_flightsys(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c5_flightsys((SFc5_flightsysInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c5_flightsys(SimStruct *S)
{
  /* Actual parameters from chart:
     params
   */
  const char_T *rtParamNames[] = { "p1" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0],
    sf_get_param_data_type_id(S,0));
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("flightsys","flightsys",5);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("flightsys","flightsys",5,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("flightsys","flightsys",5,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"flightsys","flightsys",5,4);
      sf_mark_chart_reusable_outputs(S,"flightsys","flightsys",5,1);
    }

    sf_set_rtw_dwork_info(S,"flightsys","flightsys",5);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2630513794U));
  ssSetChecksum1(S,(2497495670U));
  ssSetChecksum2(S,(1984453509U));
  ssSetChecksum3(S,(3807323119U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c5_flightsys(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "flightsys", "flightsys",5);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c5_flightsys(SimStruct *S)
{
  SFc5_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc5_flightsysInstanceStruct *)malloc(sizeof
    (SFc5_flightsysInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc5_flightsysInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c5_flightsys;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c5_flightsys;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c5_flightsys;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c5_flightsys;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c5_flightsys;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c5_flightsys;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c5_flightsys;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c5_flightsys;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c5_flightsys;
  chartInstance->chartInfo.mdlStart = mdlStart_c5_flightsys;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c5_flightsys;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info(chartInstance);
  }

  chart_debug_initialization(S,1);
}

void c5_flightsys_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c5_flightsys(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c5_flightsys(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c5_flightsys(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c5_flightsys_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
