#ifndef __c5_flightsys_h__
#define __c5_flightsys_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef struct_sGahFmRupzQTjvjnM9DdYgE
#define struct_sGahFmRupzQTjvjnM9DdYgE

typedef struct sGahFmRupzQTjvjnM9DdYgE {
  real_T verbose;
} c5_sGahFmRupzQTjvjnM9DdYgE;

#else

typedef struct sGahFmRupzQTjvjnM9DdYgE c5_sGahFmRupzQTjvjnM9DdYgE;

#endif

typedef struct {
  const char *context;
  const char *name;
  const char *dominantType;
  const char *resolved;
  uint32_T fileLength;
  uint32_T fileTime1;
  uint32_T fileTime2;
} c5_ResolvedFunctionInfo;

#ifndef struct_struct_TZDD5MhBxakygLGdeFZx9C_tag
#define struct_struct_TZDD5MhBxakygLGdeFZx9C_tag

typedef struct struct_TZDD5MhBxakygLGdeFZx9C_tag {
  real_T B[18];
  real_T D[6];
  real_T alpha;
  real_T deltamin[6];
  real_T deltamax[6];
  real_T u[3];
} c5_struct_TZDD5MhBxakygLGdeFZx9C;

#else

typedef struct struct_TZDD5MhBxakygLGdeFZx9C_tag
  c5_struct_TZDD5MhBxakygLGdeFZx9C;

#endif

typedef struct {
  c5_struct_TZDD5MhBxakygLGdeFZx9C c5_params;
  SimStruct *S;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  boolean_T c5_doneDoubleBufferReInit;
  boolean_T c5_isStable;
  uint8_T c5_is_active_c5_flightsys;
  ChartInfoStruct chartInfo;
} SFc5_flightsysInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c5_flightsys_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c5_flightsys_get_check_sum(mxArray *plhs[]);
extern void c5_flightsys_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
