sigdot_new = [ sigdot.time(1) sigdot.signals.values(1) ];
count = 2;
for i=6:5:length(sigdot.time)
    sigdot_new(count,:) = [ sigdot.time(i) sigdot.signals.values(i) ];
    count = count+1;
end
prelength = length(sigdot_new);
for i=1:5
    sigdot_new(prelength+i,:) = [ 10+i*0.05 0 ];
end
scalevec = linspace(1,0,5);

dR_predvec = [ sigdot_new(:,1),sigdot_new(:,2).*0.01 ];

hold on;
plot(mpca_dR.time,mpca_dR.signals.values,'b');
plot(dR_predvec(:,1),dR_predvec(:,2),'r');
hold off;

%%
% sigdot = mpca_dY;
sigdot_new = [ sigdot.time(1) sigdot.signals.values(1) ];
count = 2;
for i=6:5:length(sigdot.time)
    sigdot_new(count,:) = [ sigdot.time(i) sigdot.signals.values(i) ];
    count = count+1;
end
prelength = length(sigdot_new);
for i=1:5
    sigdot_new(prelength+i,:) = [ 10+i*0.05 0 ];
end
scalevec = linspace(1,0.2,5);

dY_predvec = [ sigdot_new(:,1),sigdot_new(:,2).*-0.01];

hold on;
plot(mpca_dY.time,mpca_dY.signals.values,'b');
plot(dY_predvec(:,1),dY_predvec(:,2),'r');
hold off;

%%
% longdot = mpca_dP;
longdot_new = [ longdot.time(1) longdot.signals.values(1) ];
count = 2;
for i=6:5:length(longdot.time)
    longdot_new(count,:) = [ longdot.time(i) longdot.signals.values(i) ];
    count = count+1;
end
prelength = length(longdot_new);
for i=1:5
    longdot_new(prelength+i,:) = [ 10+i*0.05 0 ];
end
scalevec_long = linspace(1,0,5);

dP_predvec = [ longdot_new(:,1) longdot_new(:,2).*-0.5]; %.*-0.05

hold on;
plot(dP_predvec(:,1),dP_predvec(:,2),'r');
plot(mpca_dP.time,mpca_dP.signals.values,'g');
hold off;


%% dP CHECK %%%
for i=1:length(mpca_dP.time)
    clf;
    hold on;
    plot(mpca_dP.time,mpca_dP.signals.values,'b');
    nt = dP_pred.time(i);
    plot([ nt nt+0.05 nt+0.1 nt+0.15 nt+0.2 ],dP_pred.signals.values(i,:),'r','LineWidth',2);
    plot([ mpca_dP.time(i) mpca_dP.time(i) ], [ -1 1 ],'g');
    pause;
    hold off;
end

%%

%%% dR CHECK %%%

for i=1:length(mpca_dR.time)
    clf;
    hold on;
    plot(mpca_dR.time,mpca_dR.signals.values,'b');
    nt = dR_pred.time(i);
    plot([ nt nt+0.05 nt+0.1 nt+0.15 nt+0.2 ],dR_pred.signals.values(i,:)','r','LineWidth',2);
    plot([ mpca_dR.time(i) mpca_dR.time(i) ], [ -0.2 0.6 ],'g');
    pause;
    hold off;
end

%%

% %%% dY CHECK %%%
for i=1:length(mpca_dY.time)
    clf;
    hold on;
    plot(mpca_dY.time,mpca_dY.signals.values,'b');
    nt = dY_pred.time(i);
    plot([ nt nt+0.05 nt+0.1 nt+0.15 nt+0.2 ],dY_pred.signals.values(i,:),'r','LineWidth',2);
    plot([ mpca_dY.time(i) mpca_dY.time(i) ], [ -0.2 0.6 ],'g');
    pause;
    hold off;
end
