/* Include files */

#include "blascompat32.h"
#include "flightsys_sfun.h"
#include "c4_flightsys.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "flightsys_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char *c4_debug_family_names[10] = { "pos", "predvec", "nargin",
  "nargout", "u", "t", "dP_predvec", "scalevec_long", "realvec", "pred" };

/* Function Declarations */
static void initialize_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance);
static void initialize_params_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance);
static void enable_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance);
static void disable_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance);
static void c4_update_debugger_state_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance);
static void set_sim_state_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance, const mxArray *c4_st);
static void finalize_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance);
static void sf_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber);
static real_T c4_emlrt_marshallIn(SFc4_flightsysInstanceStruct *chartInstance,
  const mxArray *c4_find, const char_T *c4_name);
static const mxArray *c4_sf_marshall(void *chartInstanceVoid, void *c4_u);
static const mxArray *c4_b_sf_marshall(void *chartInstanceVoid, void *c4_u);
static const mxArray *c4_c_sf_marshall(void *chartInstanceVoid, void *c4_u);
static const mxArray *c4_d_sf_marshall(void *chartInstanceVoid, void *c4_u);
static const mxArray *c4_e_sf_marshall(void *chartInstanceVoid, void *c4_u);
static const mxArray *c4_f_sf_marshall(void *chartInstanceVoid, void *c4_u);
static void c4_b_emlrt_marshallIn(SFc4_flightsysInstanceStruct *chartInstance,
  const mxArray *c4_pred, const char_T *c4_name, real_T c4_y[5]);
static uint8_T c4_c_emlrt_marshallIn(SFc4_flightsysInstanceStruct *chartInstance,
  const mxArray *c4_b_is_active_c4_flightsys, const char_T *c4_name);
static void init_dsm_address_info(SFc4_flightsysInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c4_is_active_c4_flightsys = 0U;
}

static void initialize_params_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance)
{
  real_T c4_dv0[412];
  int32_T c4_i0;
  real_T c4_dv1[5];
  int32_T c4_i1;
  sf_set_error_prefix_string(
    "Embedded MATLAB Runtime Error (chart): Error evaluating data 'dP_predvec' in the parent workspace.\n");
  sf_mex_import("dP_predvec", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                &c4_dv0, 0, 0, 0U, 1, 0U, 2, 206, 2);
  for (c4_i0 = 0; c4_i0 < 412; c4_i0 = c4_i0 + 1) {
    chartInstance->c4_dP_predvec[c4_i0] = c4_dv0[c4_i0];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Embedded MATLAB Runtime Error (chart): Error evaluating data 'scalevec_long' in the parent workspace.\n");
  sf_mex_import("scalevec_long", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                &c4_dv1, 0, 0, 0U, 1, 0U, 2, 1, 5);
  for (c4_i1 = 0; c4_i1 < 5; c4_i1 = c4_i1 + 1) {
    chartInstance->c4_scalevec_long[c4_i1] = c4_dv1[c4_i1];
  }

  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c4_update_debugger_state_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance)
{
  const mxArray *c4_st = NULL;
  const mxArray *c4_y = NULL;
  int32_T c4_i2;
  real_T c4_hoistedGlobal[5];
  int32_T c4_i3;
  real_T c4_u[5];
  const mxArray *c4_b_y = NULL;
  int32_T c4_i4;
  real_T c4_b_hoistedGlobal[5];
  int32_T c4_i5;
  real_T c4_b_u[5];
  const mxArray *c4_c_y = NULL;
  uint8_T c4_c_hoistedGlobal;
  uint8_T c4_c_u;
  const mxArray *c4_d_y = NULL;
  real_T (*c4_realvec)[5];
  real_T (*c4_pred)[5];
  c4_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
  c4_st = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_createcellarray(3));
  for (c4_i2 = 0; c4_i2 < 5; c4_i2 = c4_i2 + 1) {
    c4_hoistedGlobal[c4_i2] = (*c4_pred)[c4_i2];
  }

  for (c4_i3 = 0; c4_i3 < 5; c4_i3 = c4_i3 + 1) {
    c4_u[c4_i3] = c4_hoistedGlobal[c4_i3];
  }

  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_u, 0, 0U, 1U, 0U, 1, 5));
  sf_mex_setcell(c4_y, 0, c4_b_y);
  for (c4_i4 = 0; c4_i4 < 5; c4_i4 = c4_i4 + 1) {
    c4_b_hoistedGlobal[c4_i4] = (*c4_realvec)[c4_i4];
  }

  for (c4_i5 = 0; c4_i5 < 5; c4_i5 = c4_i5 + 1) {
    c4_b_u[c4_i5] = c4_b_hoistedGlobal[c4_i5];
  }

  c4_c_y = NULL;
  sf_mex_assign(&c4_c_y, sf_mex_create("y", &c4_b_u, 0, 0U, 1U, 0U, 1, 5));
  sf_mex_setcell(c4_y, 1, c4_c_y);
  c4_c_hoistedGlobal = chartInstance->c4_is_active_c4_flightsys;
  c4_c_u = c4_c_hoistedGlobal;
  c4_d_y = NULL;
  sf_mex_assign(&c4_d_y, sf_mex_create("y", &c4_c_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c4_y, 2, c4_d_y);
  sf_mex_assign(&c4_st, c4_y);
  return c4_st;
}

static void set_sim_state_c4_flightsys(SFc4_flightsysInstanceStruct
  *chartInstance, const mxArray *c4_st)
{
  const mxArray *c4_u;
  real_T c4_dv2[5];
  int32_T c4_i6;
  real_T c4_dv3[5];
  int32_T c4_i7;
  real_T (*c4_pred)[5];
  real_T (*c4_realvec)[5];
  c4_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c4_doneDoubleBufferReInit = TRUE;
  c4_u = sf_mex_dup(c4_st);
  c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 0)),
                        "pred", c4_dv2);
  for (c4_i6 = 0; c4_i6 < 5; c4_i6 = c4_i6 + 1) {
    (*c4_pred)[c4_i6] = c4_dv2[c4_i6];
  }

  c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 1)),
                        "realvec", c4_dv3);
  for (c4_i7 = 0; c4_i7 < 5; c4_i7 = c4_i7 + 1) {
    (*c4_realvec)[c4_i7] = c4_dv3[c4_i7];
  }

  chartInstance->c4_is_active_c4_flightsys = c4_c_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c4_u, 2)),
    "is_active_c4_flightsys");
  sf_mex_destroy(&c4_u);
  c4_update_debugger_state_c4_flightsys(chartInstance);
  sf_mex_destroy(&c4_st);
}

static void finalize_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance)
{
}

static void sf_c4_flightsys(SFc4_flightsysInstanceStruct *chartInstance)
{
  int32_T c4_i8;
  int32_T c4_i9;
  int32_T c4_i10;
  int32_T c4_i11;
  int32_T c4_previousEvent;
  real_T c4_hoistedGlobal;
  real_T c4_b_hoistedGlobal;
  int32_T c4_i12;
  real_T c4_c_hoistedGlobal[412];
  int32_T c4_i13;
  real_T c4_d_hoistedGlobal[5];
  real_T c4_u;
  real_T c4_t;
  int32_T c4_i14;
  real_T c4_b_dP_predvec[412];
  int32_T c4_i15;
  real_T c4_b_scalevec_long[5];
  uint32_T c4_debug_family_var_map[10];
  static const char *c4_sv0[10] = { "pos", "predvec", "nargin", "nargout", "u",
    "t", "dP_predvec", "scalevec_long", "realvec", "pred"
  };

  real_T c4_pos;
  real_T c4_predvec[5];
  real_T c4_nargin = 4.0;
  real_T c4_nargout = 2.0;
  real_T c4_realvec[5];
  real_T c4_pred[5];
  real_T c4_b_u[5];
  int32_T c4_i16;
  int32_T c4_i17;
  boolean_T c4_c_u[206];
  const mxArray *c4_y = NULL;
  real_T c4_d_u;
  const mxArray *c4_b_y = NULL;
  int32_T c4_i18;
  int32_T c4_i19;
  int32_T c4_i20;
  int32_T c4_i21;
  int32_T c4_i22;
  real_T *c4_e_u;
  real_T *c4_b_t;
  real_T (*c4_b_realvec)[5];
  real_T (*c4_b_pred)[5];
  c4_b_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c4_b_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
  c4_e_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c4_b_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,2);
  for (c4_i8 = 0; c4_i8 < 5; c4_i8 = c4_i8 + 1) {
    _SFD_DATA_RANGE_CHECK((*c4_b_realvec)[c4_i8], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c4_e_u, 1U);
  for (c4_i9 = 0; c4_i9 < 5; c4_i9 = c4_i9 + 1) {
    _SFD_DATA_RANGE_CHECK((*c4_b_pred)[c4_i9], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c4_b_t, 3U);
  for (c4_i10 = 0; c4_i10 < 412; c4_i10 = c4_i10 + 1) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c4_dP_predvec[c4_i10], 4U);
  }

  for (c4_i11 = 0; c4_i11 < 5; c4_i11 = c4_i11 + 1) {
    _SFD_DATA_RANGE_CHECK(chartInstance->c4_scalevec_long[c4_i11], 5U);
  }

  c4_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,2);
  c4_hoistedGlobal = *c4_e_u;
  c4_b_hoistedGlobal = *c4_b_t;
  for (c4_i12 = 0; c4_i12 < 412; c4_i12 = c4_i12 + 1) {
    c4_c_hoistedGlobal[c4_i12] = chartInstance->c4_dP_predvec[c4_i12];
  }

  for (c4_i13 = 0; c4_i13 < 5; c4_i13 = c4_i13 + 1) {
    c4_d_hoistedGlobal[c4_i13] = chartInstance->c4_scalevec_long[c4_i13];
  }

  c4_u = c4_hoistedGlobal;
  c4_t = c4_b_hoistedGlobal;
  for (c4_i14 = 0; c4_i14 < 412; c4_i14 = c4_i14 + 1) {
    c4_b_dP_predvec[c4_i14] = c4_c_hoistedGlobal[c4_i14];
  }

  for (c4_i15 = 0; c4_i15 < 5; c4_i15 = c4_i15 + 1) {
    c4_b_scalevec_long[c4_i15] = c4_d_hoistedGlobal[c4_i15];
  }

  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c4_sv0, c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c4_pos, c4_d_sf_marshall, 0U);
  sf_debug_symbol_scope_add_eml(&c4_predvec, c4_sf_marshall, 1U);
  sf_debug_symbol_scope_add_eml(&c4_nargin, c4_d_sf_marshall, 2U);
  sf_debug_symbol_scope_add_eml(&c4_nargout, c4_d_sf_marshall, 3U);
  sf_debug_symbol_scope_add_eml(&c4_u, c4_d_sf_marshall, 4U);
  sf_debug_symbol_scope_add_eml(&c4_t, c4_d_sf_marshall, 5U);
  sf_debug_symbol_scope_add_eml(&c4_b_dP_predvec, c4_c_sf_marshall, 6U);
  sf_debug_symbol_scope_add_eml(&c4_b_scalevec_long, c4_b_sf_marshall, 7U);
  sf_debug_symbol_scope_add_eml(&c4_realvec, c4_sf_marshall, 8U);
  sf_debug_symbol_scope_add_eml(&c4_pred, c4_sf_marshall, 9U);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,2);
  _SFD_EML_CALL(0,4);
  c4_b_u[0] = c4_u;
  c4_b_u[1] = c4_u;
  c4_b_u[2] = c4_u;
  c4_b_u[3] = c4_u;
  c4_b_u[4] = c4_u;
  for (c4_i16 = 0; c4_i16 < 5; c4_i16 = c4_i16 + 1) {
    c4_realvec[c4_i16] = c4_b_u[c4_i16];
  }

  _SFD_EML_CALL(0,5);
  c4_pos = 0.0;
  _SFD_EML_CALL(0,6);
  for (c4_i17 = 0; c4_i17 < 206; c4_i17 = c4_i17 + 1) {
    c4_c_u[c4_i17] = (c4_b_dP_predvec[c4_i17] >= c4_t);
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_c_u, 11, 0U, 1U, 0U, 1, 206));
  c4_d_u = 1.0;
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_d_u, 0, 0U, 0U, 0U, 0));
  c4_pos = c4_emlrt_marshallIn(chartInstance, sf_mex_call_debug("find", 1U, 2U,
    14, c4_y, 14, c4_b_y), "find");
  _SFD_EML_CALL(0,7);
  for (c4_i18 = 0; c4_i18 < 5; c4_i18 = c4_i18 + 1) {
    c4_predvec[c4_i18] = c4_b_dP_predvec[_SFD_EML_ARRAY_BOUNDS_CHECK(
      "dP_predvec", (int32_T)_SFD_INTEGER_CHECK("", c4_pos + (real_T)
      c4_i18), 1, 206, 1, 0) + 205];
  }

  _SFD_EML_CALL(0,8);
  for (c4_i19 = 0; c4_i19 < 5; c4_i19 = c4_i19 + 1) {
    c4_pred[c4_i19] = 0.0;
  }

  _SFD_EML_CALL(0,9);
  for (c4_i20 = 0; c4_i20 < 5; c4_i20 = c4_i20 + 1) {
    c4_pred[c4_i20] = c4_realvec[c4_i20] * c4_b_scalevec_long[c4_i20] +
      c4_predvec[c4_i20] * (1.0 - c4_b_scalevec_long[c4_i20]);
  }

  _SFD_EML_CALL(0,-9);
  sf_debug_symbol_scope_pop();
  for (c4_i21 = 0; c4_i21 < 5; c4_i21 = c4_i21 + 1) {
    (*c4_b_realvec)[c4_i21] = c4_realvec[c4_i21];
  }

  for (c4_i22 = 0; c4_i22 < 5; c4_i22 = c4_i22 + 1) {
    (*c4_b_pred)[c4_i22] = c4_pred[c4_i22];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,2);
  _sfEvent_ = c4_previousEvent;
  sf_debug_check_for_state_inconsistency(_flightsysMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber)
{
}

static real_T c4_emlrt_marshallIn(SFc4_flightsysInstanceStruct *chartInstance,
  const mxArray *c4_find, const char_T *c4_name)
{
  real_T c4_y;
  real_T c4_d0;
  sf_mex_import(c4_name, sf_mex_dup(c4_find), &c4_d0, 1, 0, 0U, 0, 0U, 0);
  c4_y = c4_d0;
  sf_mex_destroy(&c4_find);
  return c4_y;
}

static const mxArray *c4_sf_marshall(void *chartInstanceVoid, void *c4_u)
{
  const mxArray *c4_y = NULL;
  int32_T c4_i23;
  real_T c4_b_u[5];
  const mxArray *c4_b_y = NULL;
  SFc4_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc4_flightsysInstanceStruct *)chartInstanceVoid;
  c4_y = NULL;
  for (c4_i23 = 0; c4_i23 < 5; c4_i23 = c4_i23 + 1) {
    c4_b_u[c4_i23] = (*((real_T (*)[5])c4_u))[c4_i23];
  }

  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 0, 0U, 1U, 0U, 1, 5));
  sf_mex_assign(&c4_y, c4_b_y);
  return c4_y;
}

static const mxArray *c4_b_sf_marshall(void *chartInstanceVoid, void *c4_u)
{
  const mxArray *c4_y = NULL;
  int32_T c4_i24;
  real_T c4_b_u[5];
  const mxArray *c4_b_y = NULL;
  SFc4_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc4_flightsysInstanceStruct *)chartInstanceVoid;
  c4_y = NULL;
  for (c4_i24 = 0; c4_i24 < 5; c4_i24 = c4_i24 + 1) {
    c4_b_u[c4_i24] = (*((real_T (*)[5])c4_u))[c4_i24];
  }

  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 0, 0U, 1U, 0U, 2, 1, 5));
  sf_mex_assign(&c4_y, c4_b_y);
  return c4_y;
}

static const mxArray *c4_c_sf_marshall(void *chartInstanceVoid, void *c4_u)
{
  const mxArray *c4_y = NULL;
  int32_T c4_i25;
  int32_T c4_i26;
  int32_T c4_i27;
  real_T c4_b_u[412];
  const mxArray *c4_b_y = NULL;
  SFc4_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc4_flightsysInstanceStruct *)chartInstanceVoid;
  c4_y = NULL;
  c4_i25 = 0;
  for (c4_i26 = 0; c4_i26 < 2; c4_i26 = c4_i26 + 1) {
    for (c4_i27 = 0; c4_i27 < 206; c4_i27 = c4_i27 + 1) {
      c4_b_u[c4_i27 + c4_i25] = (*((real_T (*)[412])c4_u))[c4_i27 + c4_i25];
    }

    c4_i25 = c4_i25 + 206;
  }

  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 0, 0U, 1U, 0U, 2, 206, 2));
  sf_mex_assign(&c4_y, c4_b_y);
  return c4_y;
}

static const mxArray *c4_d_sf_marshall(void *chartInstanceVoid, void *c4_u)
{
  const mxArray *c4_y = NULL;
  real_T c4_b_u;
  const mxArray *c4_b_y = NULL;
  SFc4_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc4_flightsysInstanceStruct *)chartInstanceVoid;
  c4_y = NULL;
  c4_b_u = *((real_T *)c4_u);
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c4_y, c4_b_y);
  return c4_y;
}

const mxArray *sf_c4_flightsys_get_eml_resolved_functions_info(void)
{
  const mxArray *c4_nameCaptureInfo = NULL;
  c4_ResolvedFunctionInfo c4_info[5];
  c4_ResolvedFunctionInfo (*c4_b_info)[5];
  const mxArray *c4_m0 = NULL;
  int32_T c4_i28;
  c4_ResolvedFunctionInfo *c4_r0;
  c4_nameCaptureInfo = NULL;
  c4_b_info = (c4_ResolvedFunctionInfo (*)[5])c4_info;
  (*c4_b_info)[0].context = "";
  (*c4_b_info)[0].name = "ctranspose";
  (*c4_b_info)[0].dominantType = "double";
  (*c4_b_info)[0].resolved = "[B]ctranspose";
  (*c4_b_info)[0].fileLength = 0U;
  (*c4_b_info)[0].fileTime1 = 0U;
  (*c4_b_info)[0].fileTime2 = 0U;
  (*c4_b_info)[1].context = "";
  (*c4_b_info)[1].name = "ge";
  (*c4_b_info)[1].dominantType = "double";
  (*c4_b_info)[1].resolved = "[B]ge";
  (*c4_b_info)[1].fileLength = 0U;
  (*c4_b_info)[1].fileTime1 = 0U;
  (*c4_b_info)[1].fileTime2 = 0U;
  (*c4_b_info)[2].context = "";
  (*c4_b_info)[2].name = "plus";
  (*c4_b_info)[2].dominantType = "double";
  (*c4_b_info)[2].resolved = "[B]plus";
  (*c4_b_info)[2].fileLength = 0U;
  (*c4_b_info)[2].fileTime1 = 0U;
  (*c4_b_info)[2].fileTime2 = 0U;
  (*c4_b_info)[3].context = "";
  (*c4_b_info)[3].name = "times";
  (*c4_b_info)[3].dominantType = "double";
  (*c4_b_info)[3].resolved = "[B]times";
  (*c4_b_info)[3].fileLength = 0U;
  (*c4_b_info)[3].fileTime1 = 0U;
  (*c4_b_info)[3].fileTime2 = 0U;
  (*c4_b_info)[4].context = "";
  (*c4_b_info)[4].name = "minus";
  (*c4_b_info)[4].dominantType = "double";
  (*c4_b_info)[4].resolved = "[B]minus";
  (*c4_b_info)[4].fileLength = 0U;
  (*c4_b_info)[4].fileTime1 = 0U;
  (*c4_b_info)[4].fileTime2 = 0U;
  sf_mex_assign(&c4_m0, sf_mex_createstruct("nameCaptureInfo", 1, 5));
  for (c4_i28 = 0; c4_i28 < 5; c4_i28 = c4_i28 + 1) {
    c4_r0 = &c4_info[c4_i28];
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->context)), "context",
                    "nameCaptureInfo", c4_i28);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c4_r0->name)), "name",
                    "nameCaptureInfo", c4_i28);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c4_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c4_i28);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c4_i28);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c4_i28);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c4_i28
                    );
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c4_i28
                    );
  }

  sf_mex_assign(&c4_nameCaptureInfo, c4_m0);
  return c4_nameCaptureInfo;
}

static const mxArray *c4_e_sf_marshall(void *chartInstanceVoid, void *c4_u)
{
  const mxArray *c4_y = NULL;
  boolean_T c4_b_u;
  const mxArray *c4_b_y = NULL;
  SFc4_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc4_flightsysInstanceStruct *)chartInstanceVoid;
  c4_y = NULL;
  c4_b_u = *((boolean_T *)c4_u);
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 11, 0U, 0U, 0U, 0));
  sf_mex_assign(&c4_y, c4_b_y);
  return c4_y;
}

static const mxArray *c4_f_sf_marshall(void *chartInstanceVoid, void *c4_u)
{
  const mxArray *c4_y = NULL;
  real_T c4_b_u;
  const mxArray *c4_b_y = NULL;
  SFc4_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc4_flightsysInstanceStruct *)chartInstanceVoid;
  c4_y = NULL;
  c4_b_u = *((real_T *)c4_u);
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c4_y, c4_b_y);
  return c4_y;
}

static void c4_b_emlrt_marshallIn(SFc4_flightsysInstanceStruct *chartInstance,
  const mxArray *c4_pred, const char_T *c4_name, real_T
  c4_y[5])
{
  real_T c4_dv4[5];
  int32_T c4_i29;
  sf_mex_import(c4_name, sf_mex_dup(c4_pred), &c4_dv4, 1, 0, 0U, 1, 0U, 1, 5);
  for (c4_i29 = 0; c4_i29 < 5; c4_i29 = c4_i29 + 1) {
    c4_y[c4_i29] = c4_dv4[c4_i29];
  }

  sf_mex_destroy(&c4_pred);
}

static uint8_T c4_c_emlrt_marshallIn(SFc4_flightsysInstanceStruct *chartInstance,
  const mxArray *c4_b_is_active_c4_flightsys, const
  char_T *c4_name)
{
  uint8_T c4_y;
  uint8_T c4_u0;
  sf_mex_import(c4_name, sf_mex_dup(c4_b_is_active_c4_flightsys), &c4_u0, 1, 3,
                0U, 0, 0U, 0);
  c4_y = c4_u0;
  sf_mex_destroy(&c4_b_is_active_c4_flightsys);
  return c4_y;
}

static void init_dsm_address_info(SFc4_flightsysInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c4_flightsys_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2401308615U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1058915693U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4124514626U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3045401850U);
}

mxArray *sf_c4_flightsys_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1719986712U);
    pr[1] = (double)(3133598610U);
    pr[2] = (double)(2059415610U);
    pr[3] = (double)(3776601299U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(206);
      pr[1] = (double)(2);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(5);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(5);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(5);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c4_flightsys(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"pred\",},{M[1],M[11],T\"realvec\",},{M[8],M[0],T\"is_active_c4_flightsys\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c4_flightsys_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc4_flightsysInstanceStruct *chartInstance;
    chartInstance = (SFc4_flightsysInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_flightsysMachineNumber_,
          4,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_flightsysMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_flightsysMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_flightsysMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 5;
            _SFD_SET_DATA_PROPS(0,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"realvec",0,(MexFcnForType)c4_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"u",0,
                              (MexFcnForType)c4_f_sf_marshall);

          {
            unsigned int dimVector[1];
            dimVector[0]= 5;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"pred",0,(MexFcnForType)c4_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"t",0,
                              (MexFcnForType)c4_d_sf_marshall);

          {
            unsigned int dimVector[2];
            dimVector[0]= 206;
            dimVector[1]= 2;
            _SFD_SET_DATA_PROPS(4,10,0,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"dP_predvec",0,(MexFcnForType)
                                c4_c_sf_marshall);
          }

          {
            unsigned int dimVector[2];
            dimVector[0]= 1;
            dimVector[1]= 5;
            _SFD_SET_DATA_PROPS(5,10,0,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"scalevec_long",0,(MexFcnForType)
                                c4_b_sf_marshall);
          }

          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,332);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c4_realvec)[5];
          real_T *c4_u;
          real_T (*c4_pred)[5];
          real_T *c4_t;
          c4_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c4_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
          c4_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          c4_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c4_realvec);
          _SFD_SET_DATA_VALUE_PTR(1U, c4_u);
          _SFD_SET_DATA_VALUE_PTR(2U, c4_pred);
          _SFD_SET_DATA_VALUE_PTR(3U, c4_t);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c4_dP_predvec);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c4_scalevec_long);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_flightsysMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c4_flightsys(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc4_flightsysInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c4_flightsys((SFc4_flightsysInstanceStruct*)
    chartInstanceVar);
  initialize_c4_flightsys((SFc4_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c4_flightsys(void *chartInstanceVar)
{
  enable_c4_flightsys((SFc4_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c4_flightsys(void *chartInstanceVar)
{
  disable_c4_flightsys((SFc4_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c4_flightsys(void *chartInstanceVar)
{
  sf_c4_flightsys((SFc4_flightsysInstanceStruct*) chartInstanceVar);
}

static mxArray* sf_internal_get_sim_state_c4_flightsys(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c4_flightsys((SFc4_flightsysInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = sf_get_sim_state_info_c4_flightsys();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

static void sf_internal_set_sim_state_c4_flightsys(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_flightsys();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c4_flightsys((SFc4_flightsysInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static mxArray* sf_opaque_get_sim_state_c4_flightsys(SimStruct* S)
{
  return sf_internal_get_sim_state_c4_flightsys(S);
}

static void sf_opaque_set_sim_state_c4_flightsys(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c4_flightsys(S, st);
}

static void sf_opaque_terminate_c4_flightsys(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc4_flightsysInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c4_flightsys((SFc4_flightsysInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c4_flightsys(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c4_flightsys((SFc4_flightsysInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c4_flightsys(SimStruct *S)
{
  /* Actual parameters from chart:
     dP_predvec scalevec_long
   */
  const char_T *rtParamNames[] = { "p1", "p2" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for dP_predvec*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for scalevec_long*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("flightsys","flightsys",4);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("flightsys","flightsys",4,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("flightsys","flightsys",4,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"flightsys","flightsys",4,2);
      sf_mark_chart_reusable_outputs(S,"flightsys","flightsys",4,2);
    }

    sf_set_rtw_dwork_info(S,"flightsys","flightsys",4);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2043766580U));
  ssSetChecksum1(S,(345043154U));
  ssSetChecksum2(S,(311070429U));
  ssSetChecksum3(S,(3520515120U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c4_flightsys(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "flightsys", "flightsys",4);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c4_flightsys(SimStruct *S)
{
  SFc4_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc4_flightsysInstanceStruct *)malloc(sizeof
    (SFc4_flightsysInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc4_flightsysInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c4_flightsys;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c4_flightsys;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c4_flightsys;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c4_flightsys;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c4_flightsys;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c4_flightsys;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c4_flightsys;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c4_flightsys;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c4_flightsys;
  chartInstance->chartInfo.mdlStart = mdlStart_c4_flightsys;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c4_flightsys;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info(chartInstance);
  }

  chart_debug_initialization(S,1);
}

void c4_flightsys_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c4_flightsys(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c4_flightsys(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c4_flightsys(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c4_flightsys_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
