figure(1);
hold on;
scale = 0.003;
plot(latdot.time,latdot.signals.values.*scale,'b');
plot(dR.time,dR.signals.values,'r');
hold off;

figure(2);
hold on;
scale = -0.005;
plot(latdot.time,latdot.signals.values.*scale,'b');
plot(dY.time,dY.signals.values,'r');
hold off;

window = 20;
dR_ff = zeros(1,window);
dP_ff = zeros(1,window);
dY_ff = zeros(1,window);
times = 0;

for i=1:length(dR.time)-window
%     dR_ff(i,:) = dR.signals.values(i:i+window-1);
%     dP_ff(i,:) = dP.signals.values(i:i+window-1);
%     dY_ff(i,:) = dY.signals.values(i:i+window-1);
    dR_ff(i,:) = latdot.signals.values(i:i+window-1).*0.003;
    dP_ff(i,:) = zeros(1,window);
    dY_ff(i,:) = latdot.signals.values(i:i+window-1).*-0.005;
    
    weight = [ linspace(1,0.8,window) ];
    composite_pred = [ ones(1,window)*dR.signals.values(i).*weight + dR_ff(i,:).*(1-weight) ];
%     clf;
%     hold on;
%     plot(1:length(dR.time),dR.signals.values,'r');
%     axis tight
%     plot(i:i+window-1,composite_pred,'b','LineWidth',2);
%     plot([ i i ], [ 0.5 -0.1 ], 'g');
%     display(strcat([ 'Start:', num2str(dR.time(i)), ' Stop: ', num2str(dR.time(i+window-1)) ] ));
%     display(strcat([ 'Diff: ', num2str(dR.time(i+window-1)-dR.time(i))] ));
    times(i) = dR.time(i+window-1)-dR.time(i);
%     pause;
end




predvec = [ latdot.time latdot.signals.values.*0.003  latdot.signals.values.*-0.005 zeros(length(latdot.time),1) ];