/* Include files */

#include "blascompat32.h"
#include "flightsys_sfun.h"
#include "c3_flightsys.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "flightsys_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static const char *c3_debug_family_names[8] = { "nargin", "nargout", "u", "t",
  "sigdot_new", "scalevec", "realvec", "pred" };

/* Function Declarations */
static void initialize_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance);
static void initialize_params_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance);
static void enable_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance);
static void disable_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance);
static void c3_update_debugger_state_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance);
static void set_sim_state_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance, const mxArray *c3_st);
static void finalize_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance);
static void sf_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber);
static const mxArray *c3_sf_marshall(void *chartInstanceVoid, void *c3_u);
static const mxArray *c3_b_sf_marshall(void *chartInstanceVoid, void *c3_u);
static const mxArray *c3_c_sf_marshall(void *chartInstanceVoid, void *c3_u);
static const mxArray *c3_d_sf_marshall(void *chartInstanceVoid, void *c3_u);
static void c3_emlrt_marshallIn(SFc3_flightsysInstanceStruct *chartInstance,
  const mxArray *c3_pred, const char_T *c3_name, real_T c3_y[5]);
static void c3_b_emlrt_marshallIn(SFc3_flightsysInstanceStruct *chartInstance,
  const mxArray *c3_realvec, const char_T *c3_name, real_T c3_y[5]);
static uint8_T c3_c_emlrt_marshallIn(SFc3_flightsysInstanceStruct *chartInstance,
  const mxArray *c3_b_is_active_c3_flightsys, const char_T *c3_name);
static void init_dsm_address_info(SFc3_flightsysInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c3_is_active_c3_flightsys = 0U;
}

static void initialize_params_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance)
{
  real_T c3_d0;
  real_T c3_d1;
  sf_set_error_prefix_string(
    "Embedded MATLAB Runtime Error (chart): Error evaluating data 'sigdot_new' in the parent workspace.\n");
  sf_mex_import("sigdot_new", sf_mex_get_sfun_param(chartInstance->S, 1, 0),
                &c3_d0, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c3_sigdot_new = c3_d0;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
  sf_set_error_prefix_string(
    "Embedded MATLAB Runtime Error (chart): Error evaluating data 'scalevec' in the parent workspace.\n");
  sf_mex_import("scalevec", sf_mex_get_sfun_param(chartInstance->S, 0, 0),
                &c3_d1, 0, 0, 0U, 0, 0U, 0);
  chartInstance->c3_scalevec = c3_d1;
  sf_set_error_prefix_string("Stateflow Runtime Error (chart): ");
}

static void enable_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c3_update_debugger_state_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance)
{
  const mxArray *c3_st = NULL;
  const mxArray *c3_y = NULL;
  int32_T c3_i0;
  real_T c3_hoistedGlobal[5];
  int32_T c3_i1;
  real_T c3_u[5];
  const mxArray *c3_b_y = NULL;
  int32_T c3_i2;
  real_T c3_b_hoistedGlobal[5];
  int32_T c3_i3;
  real_T c3_b_u[5];
  const mxArray *c3_c_y = NULL;
  uint8_T c3_c_hoistedGlobal;
  uint8_T c3_c_u;
  const mxArray *c3_d_y = NULL;
  real_T (*c3_realvec)[5];
  real_T (*c3_pred)[5];
  c3_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
  c3_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
  c3_st = NULL;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_createcellarray(3));
  for (c3_i0 = 0; c3_i0 < 5; c3_i0 = c3_i0 + 1) {
    c3_hoistedGlobal[c3_i0] = (*c3_pred)[c3_i0];
  }

  for (c3_i1 = 0; c3_i1 < 5; c3_i1 = c3_i1 + 1) {
    c3_u[c3_i1] = c3_hoistedGlobal[c3_i1];
  }

  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", &c3_u, 0, 0U, 1U, 0U, 1, 5));
  sf_mex_setcell(c3_y, 0, c3_b_y);
  for (c3_i2 = 0; c3_i2 < 5; c3_i2 = c3_i2 + 1) {
    c3_b_hoistedGlobal[c3_i2] = (*c3_realvec)[c3_i2];
  }

  for (c3_i3 = 0; c3_i3 < 5; c3_i3 = c3_i3 + 1) {
    c3_b_u[c3_i3] = c3_b_hoistedGlobal[c3_i3];
  }

  c3_c_y = NULL;
  sf_mex_assign(&c3_c_y, sf_mex_create("y", &c3_b_u, 0, 0U, 1U, 0U, 2, 1, 5));
  sf_mex_setcell(c3_y, 1, c3_c_y);
  c3_c_hoistedGlobal = chartInstance->c3_is_active_c3_flightsys;
  c3_c_u = c3_c_hoistedGlobal;
  c3_d_y = NULL;
  sf_mex_assign(&c3_d_y, sf_mex_create("y", &c3_c_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c3_y, 2, c3_d_y);
  sf_mex_assign(&c3_st, c3_y);
  return c3_st;
}

static void set_sim_state_c3_flightsys(SFc3_flightsysInstanceStruct
  *chartInstance, const mxArray *c3_st)
{
  const mxArray *c3_u;
  real_T c3_dv0[5];
  int32_T c3_i4;
  real_T c3_dv1[5];
  int32_T c3_i5;
  real_T (*c3_pred)[5];
  real_T (*c3_realvec)[5];
  c3_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
  c3_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c3_doneDoubleBufferReInit = TRUE;
  c3_u = sf_mex_dup(c3_st);
  c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 0)), "pred",
                      c3_dv0);
  for (c3_i4 = 0; c3_i4 < 5; c3_i4 = c3_i4 + 1) {
    (*c3_pred)[c3_i4] = c3_dv0[c3_i4];
  }

  c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 1)),
                        "realvec", c3_dv1);
  for (c3_i5 = 0; c3_i5 < 5; c3_i5 = c3_i5 + 1) {
    (*c3_realvec)[c3_i5] = c3_dv1[c3_i5];
  }

  chartInstance->c3_is_active_c3_flightsys = c3_c_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c3_u, 2)),
    "is_active_c3_flightsys");
  sf_mex_destroy(&c3_u);
  c3_update_debugger_state_c3_flightsys(chartInstance);
  sf_mex_destroy(&c3_st);
}

static void finalize_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance)
{
}

static void sf_c3_flightsys(SFc3_flightsysInstanceStruct *chartInstance)
{
  int32_T c3_i6;
  int32_T c3_i7;
  int32_T c3_previousEvent;
  real_T c3_hoistedGlobal;
  real_T c3_b_hoistedGlobal;
  real_T c3_c_hoistedGlobal;
  real_T c3_d_hoistedGlobal;
  real_T c3_u;
  real_T c3_t;
  real_T c3_b_sigdot_new;
  real_T c3_b_scalevec;
  uint32_T c3_debug_family_var_map[8];
  real_T c3_nargin = 4.0;
  real_T c3_nargout = 2.0;
  real_T c3_realvec[5];
  real_T c3_pred[5];
  int32_T c3_i8;
  int32_T c3_i9;
  int32_T c3_i10;
  real_T *c3_b_u;
  real_T *c3_b_t;
  real_T (*c3_b_pred)[5];
  real_T (*c3_b_realvec)[5];
  c3_b_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c3_b_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
  c3_b_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c3_b_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,1);
  for (c3_i6 = 0; c3_i6 < 5; c3_i6 = c3_i6 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_realvec)[c3_i6], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c3_b_u, 1U);
  for (c3_i7 = 0; c3_i7 < 5; c3_i7 = c3_i7 + 1) {
    _SFD_DATA_RANGE_CHECK((*c3_b_pred)[c3_i7], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c3_b_t, 3U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c3_sigdot_new, 4U);
  _SFD_DATA_RANGE_CHECK(chartInstance->c3_scalevec, 5U);
  c3_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,1);
  c3_hoistedGlobal = *c3_b_u;
  c3_b_hoistedGlobal = *c3_b_t;
  c3_c_hoistedGlobal = chartInstance->c3_sigdot_new;
  c3_d_hoistedGlobal = chartInstance->c3_scalevec;
  c3_u = c3_hoistedGlobal;
  c3_t = c3_b_hoistedGlobal;
  c3_b_sigdot_new = c3_c_hoistedGlobal;
  c3_b_scalevec = c3_d_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 8U, 8U, c3_debug_family_names,
    c3_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c3_nargin, c3_c_sf_marshall, 0U);
  sf_debug_symbol_scope_add_eml(&c3_nargout, c3_c_sf_marshall, 1U);
  sf_debug_symbol_scope_add_eml(&c3_u, c3_c_sf_marshall, 2U);
  sf_debug_symbol_scope_add_eml(&c3_t, c3_c_sf_marshall, 3U);
  sf_debug_symbol_scope_add_eml(&c3_b_sigdot_new, c3_c_sf_marshall, 4U);
  sf_debug_symbol_scope_add_eml(&c3_b_scalevec, c3_c_sf_marshall, 5U);
  sf_debug_symbol_scope_add_eml(&c3_realvec, c3_b_sf_marshall, 6U);
  sf_debug_symbol_scope_add_eml(&c3_pred, c3_sf_marshall, 7U);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,2);
  _SFD_EML_CALL(0,4);
  c3_realvec[0] = c3_u;
  c3_realvec[1] = c3_u;
  c3_realvec[2] = c3_u;
  c3_realvec[3] = c3_u;
  c3_realvec[4] = c3_u;

  /*      pos = 0; */
  /*      pos = find(sigdot_new(:,1)>=t,1); */
  /*      predvec = sigdot_new(pos:pos+4,2).*-0.005; */
  _SFD_EML_CALL(0,8);
  for (c3_i8 = 0; c3_i8 < 5; c3_i8 = c3_i8 + 1) {
    c3_pred[c3_i8] = 0.0;
  }

  /*      pred = [ realvec.*scalevec + predvec'.*(1-scalevec) ]'; */
  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c3_i9 = 0; c3_i9 < 5; c3_i9 = c3_i9 + 1) {
    (*c3_b_realvec)[c3_i9] = c3_realvec[c3_i9];
  }

  for (c3_i10 = 0; c3_i10 < 5; c3_i10 = c3_i10 + 1) {
    (*c3_b_pred)[c3_i10] = c3_pred[c3_i10];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,1);
  _sfEvent_ = c3_previousEvent;
  sf_debug_check_for_state_inconsistency(_flightsysMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber)
{
}

static const mxArray *c3_sf_marshall(void *chartInstanceVoid, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i11;
  real_T c3_b_u[5];
  const mxArray *c3_b_y = NULL;
  SFc3_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc3_flightsysInstanceStruct *)chartInstanceVoid;
  c3_y = NULL;
  for (c3_i11 = 0; c3_i11 < 5; c3_i11 = c3_i11 + 1) {
    c3_b_u[c3_i11] = (*((real_T (*)[5])c3_u))[c3_i11];
  }

  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", &c3_b_u, 0, 0U, 1U, 0U, 1, 5));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_b_sf_marshall(void *chartInstanceVoid, void *c3_u)
{
  const mxArray *c3_y = NULL;
  int32_T c3_i12;
  real_T c3_b_u[5];
  const mxArray *c3_b_y = NULL;
  SFc3_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc3_flightsysInstanceStruct *)chartInstanceVoid;
  c3_y = NULL;
  for (c3_i12 = 0; c3_i12 < 5; c3_i12 = c3_i12 + 1) {
    c3_b_u[c3_i12] = (*((real_T (*)[5])c3_u))[c3_i12];
  }

  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", &c3_b_u, 0, 0U, 1U, 0U, 2, 1, 5));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static const mxArray *c3_c_sf_marshall(void *chartInstanceVoid, void *c3_u)
{
  const mxArray *c3_y = NULL;
  real_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  SFc3_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc3_flightsysInstanceStruct *)chartInstanceVoid;
  c3_y = NULL;
  c3_b_u = *((real_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", &c3_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

const mxArray *sf_c3_flightsys_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo = NULL;
  c3_ResolvedFunctionInfo c3_info[1];
  c3_ResolvedFunctionInfo (*c3_b_info)[1];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i13;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_b_info = (c3_ResolvedFunctionInfo (*)[1])c3_info;
  (*c3_b_info)[0].context = "";
  (*c3_b_info)[0].name = "ctranspose";
  (*c3_b_info)[0].dominantType = "double";
  (*c3_b_info)[0].resolved = "[B]ctranspose";
  (*c3_b_info)[0].fileLength = 0U;
  (*c3_b_info)[0].fileTime1 = 0U;
  (*c3_b_info)[0].fileTime2 = 0U;
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 1));
  for (c3_i13 = 0; c3_i13 < 1; c3_i13 = c3_i13 + 1) {
    c3_r0 = &c3_info[c3_i13];
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->context)), "context",
                    "nameCaptureInfo", c3_i13);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c3_r0->name)), "name",
                    "nameCaptureInfo", c3_i13);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c3_i13);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c3_i13);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c3_i13);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c3_i13
                    );
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c3_i13
                    );
  }

  sf_mex_assign(&c3_nameCaptureInfo, c3_m0);
  return c3_nameCaptureInfo;
}

static const mxArray *c3_d_sf_marshall(void *chartInstanceVoid, void *c3_u)
{
  const mxArray *c3_y = NULL;
  boolean_T c3_b_u;
  const mxArray *c3_b_y = NULL;
  SFc3_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc3_flightsysInstanceStruct *)chartInstanceVoid;
  c3_y = NULL;
  c3_b_u = *((boolean_T *)c3_u);
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", &c3_b_u, 11, 0U, 0U, 0U, 0));
  sf_mex_assign(&c3_y, c3_b_y);
  return c3_y;
}

static void c3_emlrt_marshallIn(SFc3_flightsysInstanceStruct *chartInstance,
  const mxArray *c3_pred, const char_T *c3_name, real_T
  c3_y[5])
{
  real_T c3_dv2[5];
  int32_T c3_i14;
  sf_mex_import(c3_name, sf_mex_dup(c3_pred), &c3_dv2, 1, 0, 0U, 1, 0U, 1, 5);
  for (c3_i14 = 0; c3_i14 < 5; c3_i14 = c3_i14 + 1) {
    c3_y[c3_i14] = c3_dv2[c3_i14];
  }

  sf_mex_destroy(&c3_pred);
}

static void c3_b_emlrt_marshallIn(SFc3_flightsysInstanceStruct *chartInstance,
  const mxArray *c3_realvec, const char_T *c3_name,
  real_T c3_y[5])
{
  real_T c3_dv3[5];
  int32_T c3_i15;
  sf_mex_import(c3_name, sf_mex_dup(c3_realvec), &c3_dv3, 1, 0, 0U, 1, 0U, 2, 1,
                5);
  for (c3_i15 = 0; c3_i15 < 5; c3_i15 = c3_i15 + 1) {
    c3_y[c3_i15] = c3_dv3[c3_i15];
  }

  sf_mex_destroy(&c3_realvec);
}

static uint8_T c3_c_emlrt_marshallIn(SFc3_flightsysInstanceStruct *chartInstance,
  const mxArray *c3_b_is_active_c3_flightsys, const
  char_T *c3_name)
{
  uint8_T c3_y;
  uint8_T c3_u0;
  sf_mex_import(c3_name, sf_mex_dup(c3_b_is_active_c3_flightsys), &c3_u0, 1, 3,
                0U, 0, 0U, 0);
  c3_y = c3_u0;
  sf_mex_destroy(&c3_b_is_active_c3_flightsys);
  return c3_y;
}

static void init_dsm_address_info(SFc3_flightsysInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c3_flightsys_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3660762589U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2779625074U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(638605308U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3024681974U);
}

mxArray *sf_c3_flightsys_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3871402733U);
    pr[1] = (double)(2875133147U);
    pr[2] = (double)(3719268396U);
    pr[3] = (double)(3396215931U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxData);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(5);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(5);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c3_flightsys(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[5],T\"pred\",},{M[1],M[10],T\"realvec\",},{M[8],M[0],T\"is_active_c3_flightsys\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c3_flightsys_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc3_flightsysInstanceStruct *chartInstance;
    chartInstance = (SFc3_flightsysInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_flightsysMachineNumber_,
          3,
          1,
          1,
          6,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_flightsysMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_flightsysMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_flightsysMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 1;
            dimVector[1]= 5;
            _SFD_SET_DATA_PROPS(0,2,0,1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"realvec",0,(MexFcnForType)
                                c3_b_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"u",0,
                              (MexFcnForType)c3_c_sf_marshall);

          {
            unsigned int dimVector[1];
            dimVector[0]= 5;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"pred",0,(MexFcnForType)c3_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"t",0,
                              (MexFcnForType)c3_c_sf_marshall);
          _SFD_SET_DATA_PROPS(4,10,0,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "sigdot_new",0,(MexFcnForType)c3_c_sf_marshall);
          _SFD_SET_DATA_PROPS(5,10,0,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,
                              "scalevec",0,(MexFcnForType)c3_c_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,343);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c3_realvec)[5];
          real_T *c3_u;
          real_T (*c3_pred)[5];
          real_T *c3_t;
          c3_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c3_pred = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 2);
          c3_u = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          c3_realvec = (real_T (*)[5])ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c3_realvec);
          _SFD_SET_DATA_VALUE_PTR(1U, c3_u);
          _SFD_SET_DATA_VALUE_PTR(2U, c3_pred);
          _SFD_SET_DATA_VALUE_PTR(3U, c3_t);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance->c3_sigdot_new);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance->c3_scalevec);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_flightsysMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c3_flightsys(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc3_flightsysInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c3_flightsys((SFc3_flightsysInstanceStruct*)
    chartInstanceVar);
  initialize_c3_flightsys((SFc3_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c3_flightsys(void *chartInstanceVar)
{
  enable_c3_flightsys((SFc3_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c3_flightsys(void *chartInstanceVar)
{
  disable_c3_flightsys((SFc3_flightsysInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c3_flightsys(void *chartInstanceVar)
{
  sf_c3_flightsys((SFc3_flightsysInstanceStruct*) chartInstanceVar);
}

static mxArray* sf_internal_get_sim_state_c3_flightsys(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c3_flightsys((SFc3_flightsysInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = sf_get_sim_state_info_c3_flightsys();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

static void sf_internal_set_sim_state_c3_flightsys(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_flightsys();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c3_flightsys((SFc3_flightsysInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static mxArray* sf_opaque_get_sim_state_c3_flightsys(SimStruct* S)
{
  return sf_internal_get_sim_state_c3_flightsys(S);
}

static void sf_opaque_set_sim_state_c3_flightsys(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c3_flightsys(S, st);
}

static void sf_opaque_terminate_c3_flightsys(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc3_flightsysInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c3_flightsys((SFc3_flightsysInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_flightsys(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c3_flightsys((SFc3_flightsysInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c3_flightsys(SimStruct *S)
{
  /* Actual parameters from chart:
     scalevec sigdot_new
   */
  const char_T *rtParamNames[] = { "p1", "p2" };

  ssSetNumRunTimeParams(S,ssGetSFcnParamsCount(S));

  /* registration for scalevec*/
  ssRegDlgParamAsRunTimeParam(S, 0, 0, rtParamNames[0], SS_DOUBLE);

  /* registration for sigdot_new*/
  ssRegDlgParamAsRunTimeParam(S, 1, 1, rtParamNames[1], SS_DOUBLE);
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("flightsys","flightsys",3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("flightsys","flightsys",3,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("flightsys","flightsys",3,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"flightsys","flightsys",3,2);
      sf_mark_chart_reusable_outputs(S,"flightsys","flightsys",3,2);
    }

    sf_set_rtw_dwork_info(S,"flightsys","flightsys",3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(814753329U));
  ssSetChecksum1(S,(3470784954U));
  ssSetChecksum2(S,(1552205367U));
  ssSetChecksum3(S,(2058118881U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c3_flightsys(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "flightsys", "flightsys",3);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_flightsys(SimStruct *S)
{
  SFc3_flightsysInstanceStruct *chartInstance;
  chartInstance = (SFc3_flightsysInstanceStruct *)malloc(sizeof
    (SFc3_flightsysInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc3_flightsysInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c3_flightsys;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c3_flightsys;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c3_flightsys;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c3_flightsys;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c3_flightsys;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c3_flightsys;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c3_flightsys;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c3_flightsys;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c3_flightsys;
  chartInstance->chartInfo.mdlStart = mdlStart_c3_flightsys;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_flightsys;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info(chartInstance);
  }

  chart_debug_initialization(S,1);
}

void c3_flightsys_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_flightsys(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_flightsys(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_flightsys(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c3_flightsys_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
